@PAGEFOOTING()

@SET(PAGE=1)@PAGEFOOTING(CENTER="- @REF[PAGE] -")
@center(THIS IS ONSCREEN.MSS
A COOKBOOK FOR LOOKING AT A PERFECT WRITER FILE ON THE 
SCREEN EXACTLY AS IT WILL APPEAR ON THE PRINTED PAGE
ARNOLD JOYAL - SEPTEMBER 1986 - COLAVKUG)

I often want to see a Perfect Writer .MSS file on the screen,
justified as it will be printed, so that I can see where pages
break, see the last character on a line, etc. I have seen other
methods described, but none has been as satisfactory for me as the
method I describe here.

There are three basic steps to the process.  First, you have
to have a "printer" defined in your PF.DAT file that will
generate a formatted .FIN file that can be read on your screen.  

Second, you usually have to reduce the left margin of your document to
zero length to keep the lines from wrapping on the screen.  You
do this by inserting an @@STYLE() command at the top of your file.

Third you have to format the file to produce the onscreen
readable file.

TASK ONE - DEFINING A "PRINTER" NAMED SCREEN

1.  Use SWEEP.COM, PIP.COM, etc., to put PF.DAT and PFCONFIG.COM on
a blank disk.  Run PFCONFIG.COM.  

2.  I use 8-1/2 by 11 inch paper with a printer that produces 12
characters per inch, so I answered PFCONFIG.COM's questions as
follows:
@VERBATIM[
N   (no disk change)
N   (or any key)
2   (to define printer types)
1   (to see the list of printers)
4   (to delete one of the printers on the list)
Name of printer to be deleted
3   (to update printer)
SCREEN (the name I chose for my onscreen "printer"
    1 - width 21590 micas
    2 - height 27940 micas
    3 - char width 212 micas (for 12 per inch.  Use 254 for 10 per inch)
    4 - height 423 micas
    5 - horiz 212 micas (for 12 per inch)
    6 - vert 423 micas
    7 - no (proportional print)
    9 - yes (online-readable output)
    CTRL-G 
6   (return to main menu)
6   (exit configuration program)]
@NEWPAGE
3.  Now SWEEP the PF.DAT file back on to your Perfect Writer Edit disk to
replace the previous version.  You can now format a file to the
printer named SCREEN that can not be printed, but can be seen on
your screen.

TASK TWO - PREPARING THE FILE FOR VIEWING

1.  Write your document.  Let's call it B:MYFILE.MSS.  

2.  Assume that you want to print out the file with the Perfect
Writer default settings.  I have set up my PF.DAT file to provide
2540 mica (one inch) left and right margins on 8-1/2 by 11 paper. 
This gives a line width of 6-1/2 inches.  At 12 characters per
inch, this is 78 characters per line.  With a 12 character left
margin, the 78 character line will not fit on the 80-character
screen without wrapping by ten characters.  I therefore want to
reduce the left margin to zero.

3.  Insert a command at the top of the file (before any text), or
change an existing command, @@STYLE(LEFTMARGIN 0 CHARS,
LINEWIDTH 77 CHARS).  Notice that the line width is one less than
was calculated from the size of the default margins.  Rember that
in the @@STYLE commands, the words LINEWIDTH, RIGHTMARGIN, etc.,
are one word.

4.  If you already have a command to set non-standard margins, there are
two possibilities.  If you have specified the left margin and
the line width, simply change the left margin to zero and keep
the line width the same number of characters.

5.  If you have specified the left margin as "L" characters and the
right margin as "R" characters, change the left margin to 0
characters and the right margin to "L+R+1" characters.  For
example, a business letter with a left margin of 18 characters (1-1/2
inch) and a right margin of 9 characters (3/4 inch) would have
the command @@STYLE(LEFTMARGIN 0 CHARS, RIGHTMARGIN 28 CHARS).
This is 18+9+1.

6.  Save the file with CTRL-X CTRL-S and exit with CTRL-X CTRL-C.

7.  To review, if the line width of the file to be printed is
determined by a specific @@STYLE(LINEWIDTH...) command, you can
reduce the left margin and leave the line width the same for your
onscreen version.  If the line width is determined by the paper
width and two margin specifications (such as is done in the
Perfect Writer default settings) you must have a line width one
character shorter on screen than printed.  Do this with a wider
right margin or @UX{shorter} line width on screen than calculated
for the printed page.  Here are a couple of mnemonic devices. 
@UX{L}eave @UX{L}inewidth a@UX{L}one.  @UX{SCR}unch up your @UX{SCR}een. 
If you do not make this one-character adjustment, there can be
differences in the printed and on-screen versions.  This can lead
to incorrect page breaks being displayed on your screen.
@NEWPAGE
TASK THREE - VIEWING THE FILE ON SCREEN

1.  Format the file B:MYFILE.MSS.  Before you select "G" (for go)
from the menu, however, select "D" (for format for a Different
device) and specify SCREEN.  Remember that SCREEN is now the name
of your new "printer", or "device" for on-screen readable files. 
SCREEN can be in lower case.  Then select "G" to start
formatting.  This formatting will produce a file called
B:MYFILE.FIN.

2.  "Edit" the file B:MYFILE.FIN with the "E" choice from the
main menu.  Notice that this is now a ".FIN" file.  You can
@UX{not} print it on your printer, but it will appear on the
screen in the justified format.  You can see page breaks,
verbatim environments, and centered text.  You can not see
underlines, boldface, shadowprint, etc., at least I can't on my old
model tube.  You should not try to change or edit this .FIN file.

3.  Exit with CTRL-X CTRL-C.

4.  Go back and edit B:MYFILE.MSS and make any corrections.  Use
@@NEWPAGE to force page breaks.  I sometimes specify
@@STYLE(PAPERLENGTH 14 INCHES) at the top of a file and then give
an @@NEWPAGE after I have crowded a couple of extra lines into the bottom
margin of an 11-inch page.  Do this only if you have turned off
the page numbers with @@PAGEFOOTING().

5.  Don't forget to remove, or change, the @@STYLE() command to
move the left margin back out to where you want it.  Save the
corrected file with CTRL-X CTRL-S and CTRL-X CTRL-C. 

6.  You can now format and print your original file B:FILE.MSS in
the usual way.  Choose "F" for format and "G" for go, without
choosing the "D" for other device.  Yes, you must format again -
to change B:MYFILE.FIN from an onscreen readable file that was
formatted for device SCREEN, to B:MYFILE.FIN, a printable file
formatted for your default printer.

    
model tube.  You should not try to change or edit this .FIN file.

3.  Exit with CTRL-X CTRL-C.

4.  Go back