100 '---------> COMBFIL.BAS <-------------------------
110 '           Rev. B, 25 Sep '84
120 '           by N6TX
130 '  COPYRIGHT (C) 1984 MICROCOMM
140 ' 
150 '  Designs microstrip comb-type bandpass filters,
160 '  of the type presented by N6TX in the Dec. 75
170 '  and Aug. 78 issues of "Ham Radio".
200 '---------------------------------------------
210 CLR$ = CHR$(26) ' Defines Clear-Screen String
220 PRINT CLR$
230 PI = 3.14159
240 RAD = 180 / PI
250 PRINT "COMBFIL.BAS  VERSION 1.01,  COPYRIGHT 1984, MICROCOMM"
260 PRINT : PRINT "    by N6TX, based on the bandpass filter techniques"
270 PRINT         "    presented in Dec. 75 and Aug 78 'Ham Radio'.
280 PRINT : PRINT "    This program will compute the dimensions of a"
290 PRINT         "    microstripline inductor to resonate a specified"
300 PRINT         "    capacitance at a given frequency, and compute"
310 PRINT         "    tap locations to acheive a desired bandwidth."
400 '---------------------------------------------
410 PRINT : PRINT
420 INPUT "PRINT TO SCREEN (S) OR PRINTER (P)";PRN$
430 IF PRN$="S" OR PRN$="s" THEN POKE 3,65
440 IF PRN$="P" OR PRN$="p" THEN POKE 3,129
450 REM Use LPRINT to implement print selection
460 IF PRN$="P" OR PRN$="p" OR PRN$="S" OR PRN$="s" GOTO 500
470 PRINT CLR$
480 PRINT "YOU MUST RESPOND WITH 'P' OR 'S'" : PRINT
490 GOTO 420
500 '-----------  INPUT CAPACITOR DATA  --------------
510 PRINT CLR$
520 PRINT "INPUT THE FOLLOWING CHARACTERISTICS OF THE"
530 PRINT "TRIMMER CAPACITORS:"
540 PRINT 
550 INPUT "          Minimum Capacitance       (pf)   ",CMIN
560 INPUT "          Maximum Capacitance       (pf)   ",CMAX
570 INPUT "          Shunt Loading Capacitance (pf)   ",CSHUNT
580 C0 = (CMIN + CSHUNT) * 1E-12
590 C1 = (CMAX + CSHUNT) * 1E-12
600 C = SQR (C0 * C1)
700 '-----------  INPUT FREQUENCY RESPONSE  ----------
710 PRINT CLR$
720 PRINT "INPUT THE DESIRED:"
730 PRINT
740 INPUT "          Resonant Frequency (MHz)         ",FO
750 INPUT "          3 dB Bandwidth     (MHz)         ",BW
760 F = FO * 1E+06
770 B = BW * 1E+06
780 Q = F / B
800 '------------  INPUT STRIP PARAMETERS -------
810 PRINT CLR$
820 PRINT "INPUT THE FOLLOWING CHARACTERISTICS OF THE"
830 PRINT "DESIRED MICROSTRIP:"
840 PRINT
850 INPUT "           System Impedance         (Ohms) ",ZS
860 INPUT "           Microstrip Impedance     (Ohms) ",ZO
870 INPUT "           Substrate Thickness    (inches) ",T
880 INPUT "           Substrate  Dielectric  Constant ",K
900 '------------- COMPUTE STRIPLINE PARAMETERS -----
910 W = T*((377/(ZO*(SQR(SQR(K)+K))))-1)
920 VINT = (1+(1/(SQR(1+((10*T)/W)))))/2
930 VREL = 1/SQR(1+((K-1)*VINT))
1000 '---------- COMPUTE REACTANCES  ----------------
1010 X = 1 / ( 2 * PI * F * C )
1020 ZTANK = Q * X
1030 N = SQR (ZTANK / ZS)
1040 THETA = ATN (X/ZO)
1050 WL = 3E+08 / F
1060 IN = WL * 39.37
1070 L = IN * VREL * THETA / (2 * PI)
1080 TAP = L / N
1090 GOSUB 2000
1300 '----------  PRINT RESULTS ----------------------
1310 PRINT CL$
1320 LPRINT "COMBLINE FILTER DESIGN BY MICROCOMM"
1330 LPRINT : LPRINT
1340 LPRINT "Resonant Frequency  =  ";FO; " MHz"
1350 LPRINT "3 dB Bandwidth      =  ";BW; " MHz"
1360 LPRINT "Loaded Filter Q     =  ";Q
1370 LPRINT
1380 LPRINT "Tuning Capacitance  =  ";CMIN;" to ";CMAX;" pf"
1390 LPRINT "Stray Capacitance   =  ";CSHUNT; " pf"
1400 LPRINT
1410 LPRINT "Microstrip Inductor Dimensions:"
1420 LPRINT
1430 LPRINT "Substrate Thickness =  ";T;" inch"
1440 LPRINT "Dielectric Constant =  ";K
1450 LPRINT "Inductor Width      =  ";W;" inch"
1460 LPRINT "Inductor Length     =  ";L;" inch"
1470 LPRINT
1480 LPRINT "Tap up for ";ZS;" ohm match: ";TAP;" inch"
1490 LPRINT : LPRINT
1495 LPRINT "TUNING RANGE = ";INT(FMIN);" to ";INT(FMAX); " MHz"
1497 LPRINT : LPRINT
1498 IF PRN$="S" OR PRN$="s" THEN INPUT "Press <CR> to continue",CR$
1500 LPRINT "          _________________________________ "
1510 LPRINT "          |          |          |         | "
1520 LPRINT "      C   |      C   |      C   |       _____ "
1530 LPRINT "        ---->      ---->      ---->      ___  "
1540 LPRINT "        -----      -----      -----       _   "
1550 LPRINT "         | |        | |        | |            "
1560 LPRINT "      L  | |     L  | |     L  | |            "
1570 LPRINT "         | |        | |        | |            "
1580 LPRINT "       __| |        | |        | |__          "
1590 LPRINT " IN   >__  | tap    | |    tap |  __>   OUT   "
1600 LPRINT "         | |        | |        | |            "
1610 LPRINT "         | |        | |        | |            "
1620 LPRINT "         |_|        |_|        |_|            "
1630 LPRINT "          |          |          |             "
1640 LPRINT "          |__________|__________|__________   " 
1650 LPRINT "                                          |   "  
1660 LPRINT "                                        _____ "
1670 LPRINT "                                         ___  "
1680 LPRINT "                                          _   "
1690 LPRINT : LPRINT : LPRINT
1700 '---------- LOOP BACK PROMPT  ----------------
1710 PRINT "TYPE <return> TO TRY A DIFFERENT MICROSTRIP"
1720 INPUT "INDUCTOR, 'Q' TO QUIT  ", D$
1730 IF D$ = "Q" OR D$ = "q" THEN 1750
1740 GOTO 800
1750 END
2000 '---------- CALCULATE TUNING RANGE  --------------
2010 CAP = C0
2020 FTRY = F
2030 GOSUB 3000
2040 FMAX = FRNU / 1E+06
2050 CAP = C1
2060 FTRY = F
2070 GOSUB 3000
2080 FMIN = FRNU / 1E+06
2090 RETURN
3000 '---------  ITERATIVE LOOP  -----------------------
3010 XC = X
3020 IND = XC / (2 * PI * FTRY)
3030 FRNU = 1 / (2 * PI * SQR(IND * CAP))
3040 IF INT(FRNU/1E+06) = INT(FTRY/1E+06) THEN 3070
3050 FTRY = FRNU
3060 XC = 1 / (2 * PI * FTRY * CAP)
3065 GOTO 3020
3070 RETURN
T(FRNU/1E+06) = INT(FTRY/1E+06) THEN 3070
3050 FTRY = FRNU
3060