;--------------------------------------------------------------
; DOUBLE PAGE PRINTER rev. 1.15  FEB 3, 1984
; by WML
;
;	This program was written to use the features of most of the 
;	common printers to reduce the amount of paper used to list text 
;	files that are not overly wide.  What it does is to print two 
;	pages at a time on a single sheet of paper in a side by side 
;	fashion using the compressed mode of the printer.  It looks sort 
;	of like this:
;
;	             xxxxxxxxxxxxxxxxxx  xxxxxxxxxxxxxxxxxxx
;	             xxxxxxxxxxxxxxxxxx  xxxxxxxxxxxxxxxxxxx
;	             xxxxxxxxxxxxxxxxxx  xxxxxxxxxxxxxxxxxxx
;		     .
;		     .
;		     .	
;	             xxxxxxxxxxxxxxxxxx  xxxxxxxxxxxxxxxxxxx
;
;	                 Page [  1]          Page [  2]
;
;	--- Note ---
;	Pressing any key will abort the execution of DBL
;
;--------------------------------------------------------------
;	Original vers. 1.0
;	BY:	ALAN W WARREN
;	DATE:	DEC 29, 1983
;
;	rev. 1.10
;	Fixed math error and left margin problem.
;	Will work with any printer now.
;	By Harry Kaemmerer
;	01/21/84
;
;	rev. 1.15
;	Fixed math error some more,
;	also some more left margin problems.
;	Now configured for LA34/LA50's, 8.0 in. paper.
;	Added more Usage info.
;	Changed to abort on any key press.
;	
;	Usage:
;	A>DBL FILENAME.TYP
;
;--------------------------------------------------------------
; some CP/M stuff first
;
BDOS:	EQU	5
FCB:	EQU	5CH
EOF:	EQU	26
CR:	EQU	13
FF:	EQU	12
LF:	EQU	10
TB:	EQU	09
LIST:	EQU	5
ESC:	EQU	27
;--------------------------------------------------------------
; D O  N O T Change the next two instructions...
;
	org	100H		;Start of program.
	jmp	start		;Hop over printer info.
;--------------------------------------------------------------
; define for your printer and paper here.
;
; SET FOR MANNESMANN TALLY MT160L, 11/12/85, RSS
;
WDT:	EQU	80		;8.0" WIDE
CPINCH:	EQU	167		;16.7 characters per inch
LMRG:	EQU	0		;LEFT MARGIN
GAP:	EQU	3		;CENTER GAP
LINES:	EQU	58		;58 lines per page
ALTMOD:	DB	ESC,'[','6','w',CR,'$'		;Alternate print pitch
NORMOD:	DB	ESC,'[','6','~',CR,FF,'$'	;returns printer to normal 
				;and ejects the last sheet
				;
;--------------------------------------------------------------
wide:	equ	(((wdt*cpinch)/100)-gap-lmrg)/2		;WML
;
START:	LXI	H,0
	DAD	SP
	SHLD	OLD
	LXI	SP,STAK
				;SET TOP OF MEMORY
	LHLD	BDOS-4
	MOV	A,H
	ORA	A
	SUI	35H
	STA	MEMTOP
				;OPEN FILE
	XRA	A
	STA	FCB+32
	LXI	D,FCB
	MVI	C,15
	CALL	BDOS
	LXI	H,NOFI
	INR	A
	JZ	FINIS
				;SET UP PRINTER & FILL MEMORY
	LXI	H,ALTMOD
	CALL	STRING
	LXI	D,DBUFER
	CALL	FILLER
				;FIND START OF EVEN PAGE
FINDPG:	MVI	A,LINES
	STA	LCOUNT
	LHLD	CURENT
	SHLD	ODDPAG
	MOV	B,A
FINDEV:	CALL	GNB
	CPI	EOF
	JZ	NULINE
	CPI	LF
	JNZ	FINDEV
	DCR	B
	JNZ	FINDEV
				;SET POINTERS FOR NEW LINE
NULINE:	LHLD	CURENT
	SHLD	EVENPG
	LHLD	ODDPAG
	SHLD	CURENT
				;CHECK FOR END OF FILE
	MOV	A,M
	CPI	EOF
	JZ	ENDIT
				;PRINT LINE FROM ODD PAGE
				;hpk
	IF	LMRG		;wml -- only do this if LMRG<>0
	mvi	c,lmrg		;left margin
	call	spaces		;send margin spaces
	ENDIF ;LMRG
	CALL	PRTLIN
	JC	ENDIT
				;SET POINTERS FOR MID SHEET
	LHLD	CURENT
	SHLD	ODDPAG
	LHLD	EVENPG
	SHLD	CURENT
				;END CHECK
	LDA	NDFLAG
	ORA	A
	JNZ	LNFEED
				;MIDDLE GAP
	LDA	BCOUNT
	SBI	(WIDE + GAP)
	CMA
	MOV	C,A
	CALL	SPACES
				;PRINT THE EVEN PAGE LINE
	CALL	PRTLIN
LNFEED:	CALL	CRLF
	JNZ	NULINE
				;FINISH THE PAGE
ENDIT:	CALL	CRLF
	LDA	LCOUNT
	CPI	255
	JNZ	ENDIT
				;DO THE ODD PAGE NUMBER
	MVI	C,((WIDE-PGWD)/2)
	CALL	PRTNUM
				;NOW THE EVEN PAGE NUMBER
	MVI	C,(GAP +WIDE -PGWD)
	CALL	PRTNUM
	CALL	CRLF		;FINISH THE SHEET
	LXI	H,ENDPG
	CALL	STRING
				;CHECK FOR END OF FILE
	LHLD	EVENPG
	MOV	A,M
	CPI	EOF
	JNZ	FINDPG
				;AT THE END OF THE FILE
EXIT:	LXI	H,NORMOD
	CALL	STRING
				;SIGN OFF
	LXI	H,GOOD
FINIS:	MVI	A,6
	STA	OBYTE
	CALL	STRING
	LHLD	OLD
	SPHL
	RET
;--------------------------------------------------------------
; --- SUBROUTINES ---
;
				;PRINT THE LINE
PRTLIN:	LXI	H,LBUFER
	XRA	A
	MOV	M,A
				;SET THE START OF THE LINE
STLINE:	MVI	C,WIDE
	XRA	A
	STA	BCOUNT
				;GET A BYTE & CHECK FOR END
GETBYT:	CALL	GNB
	CPI	EOF
	JZ	PRTND
	CPI	TB
	JZ	TABBER
	CPI	LF
	JZ	EOL
	CPI	CR
	JZ	GOTCR
				;IGNORE CONTROLS
	CPI	' '
	JC	GETBYT
				;PUT BYTE IN LINE BUFFER
	CALL	TOLIN
	JNZ	GETBYT
				;LINE IS TOO LONG
FNDEOL:	CALL	GNB
	ORA	A
	CPI	EOF
	JZ	PRTND
	CPI	CR
	JZ	GOTCR
	CPI	LF
	JNZ	FNDEOL
				;GOT THE END OF LINE -
				;PRINT WHATS IN LINE BUFFER
EOL:	PUSH	PSW
	LXI	H,LBUFER
	MOV	A,M
	STA	BCOUNT
				;IS THERE ANYTHING TO PRINT?
	MOV	D,A
	XRA	A
	MOV	M,A
	CMP	D
	JZ	NOPRT
				;PRINT THE LINE
PRTBUF:	INX	H
	MOV	A,M
	CPI	' '
	CNC	PCHAR
	DCR	D
	JNZ	PRTBUF
NOPRT:	POP	PSW
	RET
				;EXPAND TABS
TABBER:	PUSH	D
	LDA	BCOUNT
	ANI	7
	MOV	D,A
	MVI	A,8
	SUB	D
	MOV	D,A
				;MOVE SPACES TO BUFFER
TABLUP:	MVI	A,' '
	CALL	TOLIN
	JZ	TABEND
	DCR	D
	JNZ	TABLUP
	XRA	A
	INR	A
TABEND:	POP	D
	JZ	FNDEOL
	JMP	GETBYT
				;GOT A CARRIAGE RETURN
				;RESET LINE LENGTH
GOTCR:	CALL	SETLIN
	JMP	STLINE
				;GET LINE LENGTH
SETLIN:	LDA	BCOUNT
	LXI	H,LBUFER
	CMP	M
	RC
	MOV	M,A
	RET
				;GOT AN END OF FILE MARKER
PRTND:	STA	NDFLAG
	CALL	SETLIN
	JMP	EOL
				;MOVE A BYTE TO THE LINE BUFFER
TOLIN:	INX	H
	MOV	M,A
	LDA	BCOUNT
	INR	A
	STA	BCOUNT
	DCR	C
	RET
				;GET A BYTE FROM THE FILE BUFFER
GNB:	PUSH B
	PUSH D
	PUSH H
				;CHECK FOR QUICK KILL
	MVI	E,255
	MVI	C,6		;check for any char. typed - wml
	CALL	BDOS
	ORA	A
	JZ	CURCHK
				;KILL IS ON
	LHLD	EVENPG
	MVI	M,EOF
	JMP	ENDIT
				;CHECK CURRENT POSITION
CURCHK:	LHLD	CURENT
	CALL	COMP
	CZ	FILMEM
				;POINT TO BYTE & GETIT
	LHLD	CURENT
	MOV	A,M
	CPI	EOF
	JZ	GNBRET
	INX	H
	SHLD	CURENT
GNBRET:	POP H
	POP D
	POP B
	RET
				;FILL MEMORY
FILMEM:	LHLD	ODDPAG
	MVI	L,0
	LXI	D,DBUFER
				;MOVE ODD PAGE TO LOW END OF DISK BUFFER
MOVER:	MVI	C,128
				;MOVE ONE BLOCK AT A TIME
MEMOV:	MOV	A,M
	STAX	D
	INX H
	INX D
	DCR	C
	JNZ	MEMOV
	CALL	COMP
	JNZ	MOVER
				;READ DISK TO DE
FILLER:	PUSH	D
	MVI	C,26
	CALL	BDOS
	LXI	D,FCB
	MVI	C,20
	CALL	BDOS
				;CHECK FOR END OF DISK FILE
	POP	H
	MVI	C,128
	CPI	0
	JZ	FILTER
				;FILL  REST OF MEMORY WITH EOF ID
SETEND:	MVI	M,EOF
	INX	H
	DCR	C
	JNZ	SETEND
	CALL	COMP
	JNZ	SETEND
	JMP	SETPTR
				;FILTER OUT HIGH ORDER BITS
FILTER:	MOV	A,M
	ANI	7FH
	MOV	M,A
	INX	H
	DCR	C
	JNZ	FILTER
	CALL	COMP
	XCHG
	JNZ	FILLER
				;RESET POINTERS TO NEW ADDRESSES
SETPTR:	LHLD	ODDPAG
	LXI	D,DBUFER
	MOV	A,H
	SUB	D
	MOV	H,D
	SHLD	ODDPAG
	LHLD	EVENPG
	CALL	REPLA
	SHLD	EVENPG
	LHLD	CURENT
	CALL	REPLA
	SHLD	CURENT
	RET
				;SUBTRACT A FROM H
REPLA:	PUSH	D
	PUSH	PSW
	MOV	D,A
	MOV	A,H
	SUB	D
	MOV	H,A
	POP	PSW
	POP	D
	RET
				;COMPARE H TO TOP OF TPA
COMP:	MVI	A,0
MEMTOP:	EQU	$-1
	CMP	H
	RET
				;PRINT NUMBER OF SPACES IN C
SPACES:	MVI	A,' '
	CALL	PCHAR
	DCR	C
	JNZ	SPACES
	RET
				;CARRIAGE RETURN & LINE FEED
CRLF:	MVI	A,CR
	CALL	PCHAR
	MVI	A,LF
	CALL	PCHAR
				;DECREMENT LINES LEFT ON PAGE
	LDA	LCOUNT
	DCR	A
	STA	LCOUNT
	RET
				;PRINT THE BYTE IN A
PCHAR:	PUSH B
	PUSH D
	PUSH H
	MOV	E,A
	MVI	C,LIST
OBYTE:	EQU	$-1
	CALL	BDOS
	POP H
	POP D
	POP B
	RET
				;MOVE OVER & PRINT PAGE NUMBER
PRTNUM:	CALL	SPACES
	LXI	H,DIGIT
				;INCREMENT THE PAGE NUMBER
NXTNUM:	INR	M
	MOV	A,M
	CPI	':'
	JNZ	DIGOK
				;NUMBER TO BIG
	MVI	M,'0'
	DCX	H
	MOV	A,M
	CPI	'['
	JZ	DIGOK
				;CHECK FOR BLANK
	CPI	' '
	JNZ	NXTNUM
	MVI	M,'1'
DIGOK:	LXI	H,PGNUMB
				;PRINT STRING AT HL
STRING:	MOV	A,M
	INX	H
	CPI	'$'
	RZ
	CALL	PCHAR
	JMP	STRING
;
*************************
*			*
*	MESSAGES	*
*			*
*************************
;
ENDPG:	DB	FF,'$'		;END OF PAGE
GOOD:	DB	CR,LF,'finished',CR,LF,'$'
NOFI:	DB	CR,LF,'No File.',CR,LF,'Usage: A>DBL ufn',CR,LF
	DB	'Press any key to interrupt',CR,LF,'$'
PGNUMB:	DB	'Page: [   '
DIGIT:	DB	'0]','$'
PGWD:	EQU	$-(PGNUMB+2)
;
*************************
*			*
*	VARIABLES	*
*			*
*************************
;
CURENT:	DW	DBUFER
ODDPAG:	DW	DBUFER
EVENPG:	DW	DBUFER
OLD:	DS	2
LCOUNT:	DS	1
NDFLAG:	DS	1
BCOUNT:	DS	1
LBUFER:	EQU	$
DBUFER:	EQU	((LBUFER/256)+2)*256
STAK:	EQU	DBUFER-2
;
	END
OP H
	POP D
	POP B
	RET
				;MOVE OVER & PRINT PAGE NUMBER
PRTNUM:	CA