;	New sections are marked with asterisks.
;	
;	For more information, see the extensively commented
;	disassembly of the old BIOS on BAKUP volume IV.
;
;	Note that 1CH is the system control port.
;
;
;
;
	JMP	BOOT	;0FA48H
WBOOTE:		;FA03 
	JMP	WBOOT	;0FA99H
	JMP	CONST	;0FAF3H
	JMP	CONIN	;0FB09H
	JMP	CONOUT	;0FB2FH
	JMP	LIST	;0FB48H
	JMP	PUNCH	;0FB43H
	JMP	READER	;0FB3EH
	JMP	HOME	;0FB7CH
	JMP	SELDSK	;0FB80H
	JMP	STTRK	;0FB84H
	JMP	SETSEC	;0FB88H
	JMP	SETDMA	;0FB8CH
	JMP	READ	;0FB90H
	JMP	WRITE	;0FB98H
	JMP	LISTST	;0FB65H
	JMP	SECTRAN	;0FBA8H
INITIOBYTE:		;FA33 
	DB	81H
DSKWRT:		;FA34 
	DB	0
KEYPAD:		;FA35 
	DB	0BH,0AH,8,0CH,'0123456789-,'
	DB	0DH,'.'
INITBAUD:		;FA47 *********
	DB	5
BOOT:		;FA48 
	CALL	SYSINIT	;0FB78H
	XRA	A
	STA	CDISK	;4
	LDA	INITIOBYTE	;0FA33H
	STA	3
	LDA	INITBAUD	;0FA47H  ********* SET BAUD RATE **********
	OUT	0
	CALL	PRINTMSG	;0FBCFH
	DB	1AH,0DH,0AH,'KAYPRO II 64k '
	DB	'CP/M vers 2.2',0DH,0AH,0
	MVI	A,0C3H
	LXI	H,WBOOTE	;0FA03H
	STA	0
	SHLD	1
	LXI	H,BDOS	;0EC06H
	STA	5
	SHLD	6
	LDA	CDISK	;4
	MOV	C,A
	JMP	CCP	;0E400H
WBOOT:		;FA99 
	CALL	SYSINIT	;0FB78H
	CALL	PRINTMSG	;0FBCFH
	DB	0DH,0AH,'Warm Boot',0DH,0AH
	DB	0
WBINIT:		;FAAD 
	LXI	SP,0100H
	MVI	C,0
	CALL	SELDSK	;0FB80H
	LXI	B,0
	CALL	STTRK	;0FB84H
	LXI	H,CCP	;0E400H
	SHLD	DMAPTR	;0FC14H
	LXI	B,2C01H
LOADSEC:		;FAC4 
	PUSH	B
	CALL	SETSEC	;0FB88H
	CALL	READ	;0FB90H
	POP	B
	ORA	A
	JRNZ	WBINIT	;0FAADH
	LHLD	DMAPTR	;0FC14H
	LXI	D,80H
	DAD	D
	SHLD	DMAPTR	;0FC14H
	XRA	A
	STA	0E407H
	DCR	B
	JZ	0FA7EH
	INR	C
	MVI	A,28H
	CMP	C
	JNZ	LOADSEC	;0FAC4H
	MVI	C,10H
	PUSH	B
	MVI	C,1
	CALL	STTRK	;0FB84H
	POP	B
	JMPR	LOADSEC	;0FAC4H
CONST:		;FAF3 
	LXI	H,DRIVECOUNT	;0FBDBH ***********
	INR	M
	CZ	STOPDRIVE	;0FB28H
	LDA	3
	ANI	3
	MVI	L,33H
	JZ	CALLPROM	;0FBACH
	MVI	L,2AH
	JMP	CALLPROM	;0FBACH
CONIN:		;FB09 
	CALL	STOPDRIVE	;0FB28H ********
	LDA	3
	ANI	3
	MVI	L,36H
	JZ	CALLPROM	;0FBACH
	MVI	L,2DH
	CALL	CALLPROM	;0FBACH
	ORA	A
	RP
	ANI	1FH
	LXI	H,KEYPAD	;0FA35H
	MOV	C,A
	MVI	B,0
	DAD	B
	MOV	A,M
	RET
STOPDRIVE:		;FB28 **********
	IN	1CH
.Z80
	SET	6,A
.8080
	OUT	1CH
	RET
CONOUT:		;FB2F 
	LDA	3
	ANI	3
	MVI	L,39H
	JZ	CALLPROM	;0FBACH
	MVI	L,45H
	JMP	CALLPROM	;0FBACH
READER:		;FB3E 
	MVI	L,36H
	JMP	CALLPROM	;0FBACH
PUNCH:		;FB43 
	MVI	L,39H
	JMP	CALLPROM	;0FBACH
LIST:		;FB48 
	LDA	3
	ANI	0C0H
	MVI	L,39H
	JZ	CALLPROM	;0FBACH
	MVI	L,3FH
	CPI	80H
	JZ	CALLPROM	;0FBACH
	MVI	L,45H
	CPI	40H
	JZ	CALLPROM	;0FBACH
	MVI	L,39H
	JMP	CALLPROM	;0FBACH
LISTST:		;FB65 
	LDA	3
	ANI	0C0H
	MVI	L,42H
	JZ	CALLPROM	;0FBACH
	MVI	L,3CH
	CPI	80H
	JZ	CALLPROM	;0FBACH
	XRA	A
	RET
SYSINIT:		;FB78 
	MVI	L,3
	JMPR	CALLPROM	;0FBACH
HOME:		;FB7C 
	MVI	L,0CH
	JMPR	CALLPROM	;0FBACH
SELDSK:		;FB80 
	MVI	L,0FH
	JMPR	CALLPROM	;0FBACH
STTRK:		;FB84 
	MVI	L,12H
	JMPR	CALLPROM	;0FBACH
SETSEC:		;FB88 
	MVI	L,15H
	JMPR	CALLPROM	;0FBACH
SETDMA:		;FB8C 
	MVI	L,18H
	JMPR	CALLPROM	;0FBACH
READ:		;FB90 
	XRA	A		; **********
	STA	DRIVECOUNT	;0FBDBH
	MVI	L,1BH
	JMPR	CALLPROM	;0FBACH
WRITE:		;FB98 
	XRA	A		; **********
	STA	DRIVECOUNT	;0FBDBH
	MVI	L,1EH
	LDA	DSKWRT	;0FA34H
	ORA	A
	JRZ	CALLPROM	;0FBACH
	MVI	C,1
	JMPR	CALLPROM	;0FBACH
SECTRAN:		;FBA8 
	MVI	L,21H
	JMPR	CALLPROM	;0FBACH
CALLPROM:		;FBAC 
.Z80
	EXX
.8080
	IN	1CH
.Z80
	SET	7,A
.8080
	OUT	1CH
.Z80
	LD	(OLDSTACK),SP
.8080
	LXI	SP,NEWSTACK	;0FC00H
	LXI	D,PROMRETURN	;0FBC2H
	PUSH	D
.Z80
	EXX
.8080
	MVI	H,0
	PCHL
PROMRETURN:		;FBC2 
.Z80
	EX	AF,AF'
	LD	SP,(OLDSTACK)
.8080
	IN	1CH
.Z80
	RES	7,A
.8080
	OUT	1CH
.Z80
	EX	AF,AF'
.8080
	RET
PRINTMSG:		;FBCF 
	XTHL
	MOV	A,M
	INX	H
	XTHL
	ORA	A
	RZ
	MOV	C,A
	CALL	CONOUT	;0FB2FH
	JMPR	PRINTMSG	;0FBCFH
DRIVECOUNT:		;FBDB **************
	DB	0