* YEARGEN.CMD  Creates empty database for use with DATEBOOK.CMD.
* Good for 1984-1994.  Creates database YEAR.DBF, and index DATE.NDX.
* Enters year, months, days of week & dates into the database.
* By A.C. Scott, started 6/29/84.
* CALLED BY: None.
* CALLS:  No .CMD files; requires MTYEAR.DBF (contains structure)
* on default drive.
* Self-documenting; instructions come up below.
SET TALK OFF
ERASE
TEXT
                               YEARGEN

Utiltity program which generates an empty database for the DATEBOOK program.

The database contains 365 (366 in leap years) records with Month, Date, Day of
  the week, etc. fields filled in.  Time, Notes, & Holiday fields used
  for datebook entries are empty.

Before running YEARGEN for the new year, you should erase the current year's
  database, YEAR.DBF; or if you wish to preserve that datebook's records,
  copy it to another disk and rename it (to YEAR84.DBF, for example).

The YEAR database takes ~115K, so space constraints should be considered.  To
  run YEARGEN you must also have the file MTYEAR.DBF on the default B drive.
  This is an empty database containing the structure.

Ready to start?
 *  Old YEAR.DBF copied off and/or erased?
 *  MTYEAR.DBF also on drive B?
 *  Something else to do while the program runs? (It takes ~ 25 minutes)

HIT ANY KEY TO CONTINUE  or  HIT ESCAPE TO ABORT WITHOUT STARTING
ENDTEXT
SET CONSOLE OFF
WAIT
SET CONSOLE ON
CLEAR
ERASE
?
?
?
?
?  "    Choose one of the next 10 years to generate a new year's database"
?
?  '      (The DATEBOOK program should be obsolete well before 1994!)'
?
?
? '              5 - 1985              0 - 1990'
?
? '              6 - 1986              1 - 1991'
?
? '              7 - 1987              2 - 1992'
?
? '              8 - 1988              3 - 1993'
?
? '              9 - 1989              4 - 1994'
?
? '                         X - 1984'
?
SET CONSOLE OFF
WAIT TO YR
SET CONSOLE ON
* Initialize; get no. of days in year if leap year
IF YR ='8' .OR. YR = '2' .OR. !(YR) = 'X'
STORE 366 TO NODAYS
STORE 29 TO NOFEB
ELSE
STORE 365 TO NODAYS
STORE 28 TO NOFEB
ENDIF
* Initialize; get dayname for 01/01 for each year
DO CASE
CASE YR = '5' .OR. YR = '1'
STORE 'TU' TO FSTDAY
CASE YR = '6' .OR. YR = '2'
STORE 'WE' TO FSTDAY
CASE YR = '7'
STORE 'TH' TO FSTDAY
CASE YR = '8' .OR. YR = '3'
STORE 'FR' TO FSTDAY
CASE YR = '9' .OR. !(YR) = 'X'
STORE 'SU' TO FSTDAY
CASE YR = '0'
STORE 'MO' TO FSTDAY
CASE YR = '4'
STORE 'SA' TO FSTDAY
ENDCASE
* Initialize; get whole number of year
IF YR = '5' .OR. YR = '6' .OR. YR = '7' .OR. YR = '8' .OR. YR = '9'
STORE 1980 +VAL(YR) TO THEYEAR
ELSE
STORE 1990 +VAL(YR) TO THEYEAR
ENDIF
IF !(YR) = 'X'
STORE 1984 TO THEYEAR
ENDIF
ERASE
* display year selected & first message
@ 0,25 SAY THEYEAR
@ 1,1 SAY 'Now creating database YEAR.DBF with 365 (or 366) empty records.  '
* copy structure to database from MTYEAR
USE MTYEAR
COPY TO YEAR STRU
USE YEAR
* append 365 or 366 blanks (NODAYS = no. of records)
STORE 1 TO DACTR
DO WHILE DACTR <= NODAYS
APPEND BLANK
STORE 1 + DACTR TO DACTR
ENDDO
RELEASE DACTR
* Fill in YEAR filed with year selected
@ 3,1 SAY 'Now filling in the year.'
REPL ALL YEAR WITH THEYEAR
* fill in field DAYNAME with 'MO', 'TU', 'WE' etc.
@ 5,1 SAY 'Now filling in the days of the week.'
* Choose one of 7 loops starting with ea. day, depending on yr. selected.
* Case 1, 1st day Sunday
IF FSTDAY = 'SU'
STORE 'MO' TO DAY2  
STORE 'TU' TO DAY3  
STORE 'WE' TO DAY4
STORE 'TH' TO DAY5
STORE 'FR' TO DAY6
STORE 'SA' TO DAY7
ENDIF
* Case 2, 1st day Monday
IF FSTDAY = 'MO'
STORE 'TU' TO DAY2
STORE 'WE' TO DAY3
STORE 'TH' TO DAY4
STORE 'FR' TO DAY5
STORE 'SA' TO DAY6
STORE 'SU' TO DAY7
ENDIF
* Case 3, 1st day Tuesday
IF  FSTDAY = 'TU'
STORE 'WE' TO DAY2
STORE 'TH' TO DAY3
STORE 'FR' TO DAY4
STORE 'SA' TO DAY5
STORE 'SU' TO DAY6
STORE 'MO' TO DAY7
ENDIF
* Case 4, 1st day Wednesday
IF FSTDAY = 'WE'
STORE 'TH' TO DAY2
STORE 'FR' TO DAY3
STORE 'SA' TO DAY4
STORE 'SU' TO DAY5
STORE 'MO' TO DAY6
STORE 'TU' TO DAY7
ENDIF
* case 5, 1st day Thursday
IF FSTDAY = 'TH'
STORE 'FR' TO DAY2
STORE 'SA' TO DAY3
STORE 'SU' TO DAY4
STORE 'MO' TO DAY5
STORE 'TU' TO DAY6
STORE 'WE' TO DAY7
ENDIF
* Case 6, 1st day Friday
IF FSTDAY = 'FR'
STORE 'SA' TO DAY2
STORE 'SU' TO DAY3
STORE 'MO' TO DAY4
STORE 'TU' TO DAY5
STORE 'WE' TO DAY6
STORE 'TH' TO DAY7
ENDIF
* case 7, 1st day Saturday
IF FSTDAY = 'SA' 
STORE 'SU' TO DAY2
STORE 'MO' TO DAY3
STORE 'TU' TO DAY4
STORE 'WE' TO DAY5
STORE 'TH' TO DAY6
STORE 'FR' TO DAY7
ENDIF
* Start at 1, go through database filling in day names
goto 1
do while .not. EOF
repl dayname with FSTDAY   
skip
repl dayname with DAY2    
skip
repl dayname with DAY3
skip
repl dayname with DAY4
skip
repl dayname with DAY5
skip
repl dayname with DAY6
skip
repl dayname with DAY7
skip
enddo
go bottom
* loop stops @ last day; fill in last day with correct day name
if # = 365
repl dayname with fstday
else
repl dayname with day2
endif
RELEASE ALL LIKE DAY*
* start at 1, fill in fields MONAME, MONUM, DAYNUM
* 5,1 SAY 'Now filling in Months and dates.'
GOTO 1
STORE 1 TO CT1
DO WHILE CT1<32
REPL MONAME WITH 'JANUARY'
REPL MONUM WITH 1
REPL DAYNUM WITH CT1
STORE 1+CT1 TO CT1
SKIP 
ENDDO
STORE 1 TO CT2
* Set counter stop for FEB to NOFEB + 1, depending on whether leap year
DO WHILE CT2< (NOFEB + 1)
REPL MONAME WITH 'FEBRUARY'
REPL MONUM WITH 2
repl daynum with ct2
store 1+ct2 to ct2
skip
enddo
STORE 1 TO CT3
DO WHILE CT3<32
REPL MONAME WITH 'MARCH'   
REPL MONUM WITH 3
repl daynum with ct3
store 1+ct3 to ct3
skip
enddo
STORE 1 TO CT4
DO WHILE CT4<31
REPL MONAME WITH 'APRIL'   
REPL MONUM WITH 4
repl daynum with ct4
store 1+ct4 to ct4
skip
enddo
STORE 1 TO CT5
DO WHILE CT5<32
REPL MONAME WITH 'MAY'   
REPL MONUM WITH 5
repl daynum with ct5
store 1+ct5 to ct5
skip
enddo
STORE 1 TO CT6
DO WHILE CT6<31
REPL MONAME WITH 'JUNE'  
REPL MONUM WITH 6
repl daynum with ct6
store 1+ct6 to ct6
skip
enddo
STORE 1 TO CT7
DO WHILE CT7<32
REPL MONAME WITH 'JULY'  
REPL MONUM WITH 7
repl daynum with ct7
store 1+ct7 to ct7
skip
enddo
STORE 1 TO CT8
DO WHILE CT8<32
REPL MONAME WITH 'AUGUST'
REPL MONUM WITH 8
repl daynum with ct8
store 1+ct8 to ct8
skip
enddo
STORE 1 TO CT9
DO WHILE CT9<31
REPL MONAME WITH 'SEPTEMBER'
REPL MONUM WITH 9
repl daynum with ct9
store 1+ct9 to ct9
skip
enddo
STORE 1 TO CT10
DO WHILE CT10<32
REPL MONAME WITH 'OCTOBER'
repl monum with 10
repl daynum with ct10
store 1+ct10 to ct10
skip
enddo
STORE 1 TO CT11
DO WHILE CT11<31
REPL MONAME WITH 'NOVEMBER'
repl monum with 11
repl daynum with ct11
store 1+ct11 to ct11
skip
enddo
STORE 1 TO CT12
DO WHILE CT12<32
REPL MONAME WITH 'DECEMBER'
repl monum with 12
repl daynum with ct12
store 1+ct12 to ct12
skip
enddo
release all like CT*
* Fill in field DATE, 8 char. field, like '99/99/99'
@ 7,1 say "Now filling in dates.  Last Step before we're done!"
GOTO 1
DO WHILE .NOT. EOF
IF MONUM < 10
STORE '0' + STR(MONUM,1,0) TO MODT
ELSE
STORE STR(MONUM,2,0) TO MODT
ENDIF
IF DAYNUM < 10
STORE '0' + STR(DAYNUM,1,0) TO DADT
ELSE
STORE STR(DAYNUM,2,0) TO DADT
ENDIF
REPL DATE WITH MODT + '/' + DADT + '/' + $(STR(YEAR,4,0),3,2)
SKIP
ENDDO
* Loop stops at last date, fill in with '12/31/YR'
goto bottom
repl date with '12/31/' + $(STR(YEAR,4,0),3,2)
* Create index DATE.NDX
@ 9,1 SAY 'Almost done--now indexing, creating DATE.NDX'
INDEX ON DATE TO DATE
@ 12,10 SAY ' ALL DONE!  Use "YEAR.DBF" and list to make sure it is ok.'
SET TALK ON
RELEASE ALL
CLEAR
RETURN
* EOF YEARGEN.CMD