10 'CURVFIT7
20 'By R. S. Stein, W6NBI - 11/28/84
25 '4/30/85: Revised CURVFIT6 to add constant to log function - RSS
26 '6/16/85: Corrected bug; changed line 2470, added 4520 thru 4560 - RSS
28 '
30 'Polynomial and plot routines based on "CURVFIT" written by Ralph Johnson.
40 'Power and exponential routines based on program in "Theory and Problems of 
50 'Programming with BASIC" by Byron S. Gottfried.
55 '
60 PRINT CHR$(26)
70 PRINT TAB(20);"******* LEAST SQUARES CURVE FIT *******"
80 PRINT
90 PRINT "    THIS PROGRAM PERFORMS LEAST-SQUARES CURVE FITS FOR A LINEAR FUNCTION,"
100 PRINT "    A GENERAL POLYNOMIAL, A POWER FUNCTION, AN EXPONENTIAL FUNCTION, OR A"
110 PRINT "    LOG FUNCTION.  IT WILL ALSO EVALUATE AND PLOT THE FUNCTION, IF YOU WISH."
120		' SET UP ARRAY MEMORY
130 DIM A(20,20),B(20),C(20),X(20),Y(20),XL(20),YL(20)
140 DIM XX(120),YY(120),Q(45),YZ(20),U(20),D(20),V(20,20)
150 ON ERROR GOTO 2480
160		' MAIN PROGRAM
170 GOSUB 300
180 IF N%<2 THEN GOSUB 3390 ELSE GOTO 200	
190 GOTO 4250
200 GOSUB 990
210 GOSUB 1060
220 GOSUB 1260
230 GOSUB 1730
240 GOSUB 1860
250 GOTO 2340 
260 GOSUB 2590
270 GOSUB 3040
280 GOTO 2340
290		' END MAIN
300		' INPUT SUBROUTINE 
310 PRINT : PRINT 
320 PRINT"INPUT N=0 FOR A POWER FUNCTION"
330 PRINT"INPUT N=1 FOR AN EXPONENTIAL FUNCTION"
340 PRINT"INPUT N=2 FOR A LINEAR FUNCTION"
350 PRINT"INPUT N=99 FOR A LOG FUNCTION"
360 PRINT"FOR A POLYNOMIAL, LET N = NUMBER OF TERMS IN THE POLYNOMIAL"
370 PRINT
380 INPUT"N = ";NN
390 IF NN<>INT(NN) OR NN<0 THEN PRINT ELSE GOTO 430
400 PRINT CHR$(7);"N MUST BE A POSITIVE INTEGER -- START OVER"
410 PRINT 
420 GOTO 320
430 IF NN=99 THEN N%=1 ELSE N%=NN
440 IF Z%=2 GOTO 500
450 PRINT: PRINT 
460 INPUT"HOW MANY DATA POINTS ARE THERE (20 MAX.)";DATAPTS%
470 IF DATAPTS%>20 THEN PRINT ELSE GOTO 500
480 PRINT CHR$(7);"PROGRAM IS LIMITED TO 20 DATA POINTS -- PLEASE RE-ENTER"
490 GOTO 450
500 ORDER%=N%-1
510		' VALIDITY CHECK
520 IF ORDER%>=DATAPTS% THEN PRINT CHR$(7);"NOT ENOUGH DATA FOR THAT ORDER FIT":GOTO 310
530 IF Z%=2 GOTO 710
550 PRINT CHR$(26)
560 PRINT "ENTER THE DATA:"
565 PRINT "(You may make changes/corrections after all data points have been entered)": PRINT: PRINT 
570 FOR I%=1 TO DATAPTS%
580    PRINT"X(";I%;"), Y(";I%;")";TAB(20);
590    INPUT X(I%),Y(I%)
600    XL(I%)=X(I%)
610    YL(I%)=Y(I%)
620 NEXT I%
630 PRINT: INPUT "ARE ALL DATA ENTRIES CORRECT (Y/N)";E$
640 IF E$="Y" OR E$="y" GOTO 710
650 INPUT "ENTER THE IDENTIFYING (SUBSCRIPT) NO. OF THE DATA POINT TO BE CHANGED   ",W
655 IF W<>INT(W) OR W>DATAPTS% OR W=<0 THEN PRINT: PRINT "NOT A VALID ENTRY": GOTO 650
660 PRINT: PRINT "X(";W;"), Y(";W;")";TAB(20);
670 INPUT X(W),Y(W)
675 XL(W)=X(W)
676 YL(W)=Y(W)
680 PRINT: PRINT: INPUT "ANY MORE CHANGES (Y/N)";EE$
690 IF EE$="Y" OR EE$="y" GOTO 650
710 IF NN=99 AND EFLAG%=1 GOTO 870
720 IF N%<2 GOTO 750
730 PRINT CHR$(26)
740 RETURN
750		' CALCULATE LOGS OF X- AND Y-VALUES IF NECESSARY
760 YFLAG%=0: EFLAG%=0
765 IF NN=99 GOTO 820
770 FOR I%=1 TO DATAPTS%
780    IF Y(I%)<0 THEN YFLAG%=1
790    IF I%>1 AND Y(I%)>0 AND Y(I%-1)>0 THEN EFLAG%=1
800    Y(I%)=-Y(I%)
810 NEXT I%
820 IF YFLAG%=1 AND Y(1)<0 THEN EFLAG%=1
825 IF NN=99 GOTO 860
830 FOR I%=1 TO DATAPTS%
840    IF YFLAG%=0 OR EFLAG%=1 THEN Y(I%)=-Y(I%)
850 NEXT I%
860 IF EFLAG%=0 GOTO 895
870 PRINT: PRINT CHR$(7);"NO SOLUTION": PRINT 
880 OFLAG%=1
890 GOTO 2390
895 IF NN=99 GOTO 940
900 FOR I%=1 TO DATAPTS%
910    Y(I%)=LOG(Y(I%))
920 NEXT I%
930 IF N%=1 GOTO 970
940 FOR I%=1 TO DATAPTS%
950    X(I%)=LOG(X(I%))
960 NEXT I%
970 RETURN
980		' END INPUT
990		' RESET ARRAYS
1000 FOR I%=0 TO 20
1010    B(I%)=0
1020    Q(I%)=0
1030 NEXT I%
1040 RETURN
1050		' MATRIX LOAD
1060		' GENERATE VALUES FOR ARRAY
1070 FOR I%=0 TO ORDER%*2
1080	FOR J%=1 TO DATAPTS%
1090	   Q(I%)=X(J%)^I%+Q(I%)
1100	NEXT J%
1110    Q(I%)=2*Q(I%)
1120 NEXT I%
1130		' LOAD
1140 FOR I%=0 TO ORDER%
1150	FOR J%=0 TO ORDER%
1160	   A(I%+1,J%+1)=Q(I%+J%)
1170	NEXT J%
1180 NEXT I%
1190 FOR I%=0 TO ORDER%
1200    FOR J%=1 TO DATAPTS%
1210	   B(I%+1)=2*X(J%)^I%*Y(J%)+B(I%+1)
1220	NEXT J%
1230 NEXT I%
1240 RETURN
1250		' END MATRIX LOAD
1260		' SIMULTANEOUS EQU SOLN
1270 FLAG%=0
1280 IF N%<>0 GOTO 1320
1290 IF A(1,1)=0 THEN FLAG%=1: RETURN
1300 X(1)=B(1)/A(1,1)
1310 RETURN
1320 M%=N%-1
1330 FOR I%=1 TO M%
1340    H=ABS(A(I%,I%))
1350	L%=I%
1360	I1%=I%+1
1370	FOR J%=I1% TO N%
1380	   IF ABS(A(J%,I%))<H GOTO 1410
1390	   H=ABS(A(J%,I%))
1400	   L%=J%
1410    NEXT J%
1420	IF H=0 THEN FLAG%=1: RETURN
1430	IF L%=I% GOTO 1520
1440	FOR J%=1 TO N%
1450	   G=A(L%,J%)
1460	   A(L%,J%)=A(I%,J%)
1470	   A(I%,J%)=G
1480	NEXT J%
1490	G=B(L%)
1500	B(L%)=B(I%)
1510	B(I%)=G
1520	FOR J%=I1% TO N%
1530       T=A(J%,I%)/A(I%,I%)
1540	   FOR K%=I1% TO N%
1550          A(J%,K%)=A(J%,K%)-T*A(I%,K%)
1560	   NEXT K%
1570	   B(J%)=B(J%)-T*B(I%)
1580	NEXT J%
1590 NEXT I%
1600 IF A(N%,N%)=0 THEN FLAG%=1: RETURN
1610 C(N%)=B(N%)/A(N%,N%)
1620 I%=N%-1
1630 S=0
1640 I1%=I%+1
1650 FOR J%=I1% TO N%
1660    S=S+A(I%,J%)*C(J%)
1670 NEXT J%
1680 C(I%)=(B(I%)-S)/A(I%,I%)
1690 I%=I%-1
1700 IF I%>0 GOTO 1630
1710 RETURN
1720		' END SIMULTANEOUS EQU
1730		' SUM OF ERRORS SQRD
1740 FOR I%=1 TO DATAPTS%
1750    YZ(I%)=0
1760 NEXT I%
1770 E=0
1780 FOR I%=1 TO DATAPTS%
1790    FOR J%=1 TO N%
1800       YZ(I%)=C(J%)*X(I%)^(J%-1)+YZ(I%)
1810    NEXT J%
1820    E=E+(Y(I%)-YZ(I%))^2
1830 NEXT I%
1840 RETURN
1850		' END SUM ERRORS SQRD
1860		' OUTPUT STATEMENTS
1870 IF FLAG%=1 THEN PRINT: PRINT CHR$(7);"NO SOLUTION": RETURN
1880 IF N%>2 GOTO 1920
1890 PRINT: PRINT "LINEAR FUNCTION:  Y =";C(2);"X";
1900 IF C(N%-1)=>0 THEN PRINT " +";C(N%-1) ELSE PRINT " ";C(N%-1)
1910 GOTO 1970
1920 PRINT"LIST OF COEFFICIENTS IN POLYNOMIAL:  Y = aX^(n) + bX^(n-1) ... + zX^0":PRINT
1930 PRINT"POWER OF X","COEFFICIENT":PRINT
1940 FOR I%=N% TO 1 STEP -1
1950    PRINT "   X^";I%-1,C(I%)
1960 NEXT I%
1970 PRINT
1980 IF N%>1 THEN YFLAG%=0
1990 FOR I%=1 TO DATAPTS%
2000    IF YFLAG%=1 THEN Y(I%)=-Y(I%)
2010	PRINT"X =";X(I%),"DESIRED Y =";Y(I%),"CALCULATED Y =";YZ(I%)
2015    IF I%=10 AND DATAPTS%>10 THEN INPUT "   Press <CR> to continue",K$
2020 NEXT I%
2030 PRINT: PRINT "SUM OF ERRORS SQUARED =";E
2040		' PRINTER
2050 PRINT:PRINT
2060 INPUT "DO YOU WANT A PRINT OUT OF THIS (Y/N)";PR$
2070 IF PR$<>"y" AND PR$<>"Y" GOTO 2330
2080 IF NN=99 GOTO 2250
2090 IF N%=0 GOTO 2210
2100 IF N%=1 GOTO 2230
2110 IF N%>2 GOTO 2150
2120 LPRINT: LPRINT "LINEAR FUNCTION:  Y =";C(2);"X";
2130 IF C(N%-1)=>0 THEN LPRINT " +";C(N%-1) ELSE LPRINT " ";C(N%-1)
2140 GOTO 2260
2150 LPRINT"LIST OF COEFFICIENTS IN POLYNOMIAL:  Y=aX^(n)+bX^(n-1)...zX^0"
2160 LPRINT " ": LPRINT "POWER OF X", "COEFFICIENT": LPRINT" "
2170 FOR I%=N% TO 1 STEP -1
2180	LPRINT "    X^";I%-1,C(I%)
2190 NEXT I%
2200 GOTO 2260
2210 LPRINT: LPRINT "POWER FUNCTION:  Y =";C1;"X^(";C(2);")"
2220 GOTO 2260
2230 LPRINT: LPRINT "EXPONENTIAL FUNCTION:  Y =";C1;"* e^(";C(2);"X )"
2240 GOTO 2260
2250 LPRINT : LPRINT "LOG FUNCTION:  Y =";C(1);S$;ABS(C(2));"(ln X)"
2260 LPRINT" "
2270 FOR I%=1 TO DATAPTS%
2280	LPRINT"X =";X(I%),"DESIRED Y =";Y(I%),"CALCULATED Y =";YZ(I%)
2290 NEXT I%
2300 LPRINT: LPRINT "SUM OF ERRORS SQUARED =";E
2310 IF N%<2 GOTO 2340
2320 RETURN
2330		' END OUTPUT
2340		' OPTIONS
2350 PRINT CHR$(26): PRINT: PRINT
2360 OFLAG%=0
2370 PRINT"You have the following options:": PRINT 
2380 PRINT"	1) EVALUATE THE FUNCTION"
2390 PRINT"	2) TRY A DIFFERENT FIT"
2400 PRINT"	3) TRY A NEW DATA SET (RERUN THE PROGRAM)"
2410 PRINT"	4) EXIT THE PROGRAM"
2420 PRINT:INPUT"ENTER YOUR CHOICE  ",Z%
2430 IF OFLAG%=0 AND Z%=>1 AND Z%=<4 GOTO 2470
2440 IF OFLAG%=1 AND Z%=>2 AND Z%=<4 GOTO 2470
2450 PRINT: PRINT CHR$(7);"IMPROPER ENTRY -- TRY AGAIN": PRINT 
2460 IF OFLAG%=0 GOTO 2380 ELSE GOTO 2390
2470 ON Z% GOTO 260,4520,170,2570
2480 PRINT: PRINT: PRINT CHR$(7);"NO SOLUTION": PRINT 
2490 OFLAG%=1
2500 IF ERL>2600 AND ERL<2830 THEN PRINT "Xmin MUST BE "; ELSE GOTO 2560
2510 PRINT CHR$(7);
2515 IF NN=99 THEN PRINT "GREATER THAN ZERO"
2520 IF NN=0 THEN PRINT "ZERO OR GREATER"
2530 PRINT 
2540 OFLAG%=0
2550 RESUME 2380
2560 RESUME 2390
2570 END
2580		' END OPTIONS
2590		' EVALUATE
2600 PRINT 
2610 INPUT"SELECT THE RANGE OF X TO BE EVALUATED (Xmin,Xmax)  ",XINIT,XFIN
2620 INCR=(XFIN-XINIT)/120
2630 ZO=0
2640 FOR I%=0 TO 120
2650    XX(I%)=XINIT+INCR*I%
2660    YY(I%)=0
2670    IF NN=99 GOTO 2780
2680    IF N%<2 GOTO 2730
2690	FOR J%=1 TO N%
2700       YY(I%)=C(J%)*XX(I%)^(J%-1)+YY(I%)
2710	NEXT J%
2720    GOTO 2790
2730    IF N%=1 GOTO 2760
2740    YY(I%)=C1*XX(I%)^C(2)
2750    GOTO 2790
2760    YY(I%)=C1*EXP(C(2)*XX(I%))
2770    GOTO 2790
2780    YY(I%)=C(1)+C(2)*LOG(XX(I%))
2790    IF I%=0 THEN YMIN=YY(0):YMAX=YMIN
2800	IF YY(I%)>YMAX THEN YMAX=YY(I%)
2810	IF YY(I%)<YMIN THEN YMIN=YY(I%)
2820 NEXT I%
2830		' OUTPUT EVALUATE
2840 PRINT CHR$(26)
2850 FOR I%=0 TO 54 STEP 6
2860	PRINT "X =";XX(I%),"Y =";YY(I%);TAB(40);"X =";XX(I%+60),"Y =";YY(I%+60)
2870 NEXT I%
2880 PRINT TAB(40);"X =";XX(120),"Y =";YY(120)
2890 PRINT
2900 PRINT "Y min. =";YMIN
2910 PRINT "Y max. =";YMAX
2920 PRINT 
2930 INPUT "DO YOU WANT THIS PRINTED OUT (Y/N)";PR$
2940 IF PR$<>"Y" AND PR$<>"y" THEN RETURN
2950 FOR I%=0 TO 54 STEP 6
2960	LPRINT "X =";XX(I%),"Y =";YY(I%);TAB(40);"X =";XX(I%+60),"Y =";YY(I%+60)
2970 NEXT I%
2980 LPRINT TAB(40);"X =";XX(120),"Y =";YY(120)
2990 LPRINT" "
3000 LPRINT "Y min. =";YMIN
3010 LPRINT "Y max. =";YMAX
3020 RETURN
3030		' END EVALUATE
3040		' PLOT
3050 INPUT"DO YOU WANT A PRINTED PLOT OF THE FUNCTION (Y/N)";PLOT$
3060 IF PLOT$<>"Y" AND PLOT$<>"y" THEN RETURN
3070 INPUT"SELECT THE RANGE OF Y (Ymin,Ymax)  ",YMIN,YMAX
3075 YMAX$=STR$(YMAX)
3080 INPUT"SELECT THE PRINT WIDTH (Max. 78 for 80-column printer) ",WDTH
3085 WDTH=WDTH-11
3105 PRINT "ENTER THE CURVE NAME"
3110 INPUT "   ",NAM$
3115 YRANGE=YMAX-YMIN
3120 ZERO=(0-YMIN)*WDTH/YRANGE+.5
3140 LPRINT TAB(12);NAM$
3150 LPRINT "X";TAB(6);"Y->";
3160 LPRINT TAB(11);YMIN;
3170 IF YMAX>0 AND YMIN<0 THEN LPRINT TAB(INT(ZERO)+12);"0";
3180 LPRINT TAB(WDTH+13-LEN(YMAX$));YMAX
3190 LPRINT "\/";TAB(12);"!";
3215 FOR I%=1 TO WDTH-1
3220    LPRINT TAB(I%+12);"_";
3225 NEXT I%
3235 LPRINT TAB(WDTH+12);"!"
3240 FOR I%=0 TO 120 STEP 2
3255    PLOT$=""
3265	PLOT%=INT((YY(I%)-YMIN)*WDTH/YRANGE+.5)
3295	FOR K%=0 TO WDTH
3300       IF PLOT%=K% THEN PLOT$=PLOT$+"+": GOTO 3315
3305	   IF K%<>0 AND INT(ZERO)=K% THEN PLOT$=PLOT$+":": GOTO 3315
3310       PLOT$=PLOT$+" "
3315	NEXT K%
3320	IF I%=0 OR I%/12=INT(I%/12) THEN LPRINT USING "+#.###^^^^";XX(I%);
3335    LPRINT TAB(11);"|";PLOT$
3340 NEXT I%
3350 PRINT: INPUT "DO YOU WANT TO REPLOT THE FUNCTION (Y/N)";PLOT$
3360 IF PLOT$="Y" OR PLOT$="y" THEN PRINT: PRINT: GOTO 3070
3370 RETURN
3380		' END PLOT
3390		' CALCULATE ELEMENTS OF A-MATRIX AND D-VECTOR FOR
3400		' POWER AND EXPONENTIAL FUNCTIONS
3410 N1=2
3420		' MATRIX ZERO ROUTINES
3430		' MAT A=ZER(N1,N1)
3440 FOR I%=1 TO N1
3450    FOR J%=1 TO N1
3460       A(I%,J%)=0
3470    NEXT J%
3480 NEXT I%
3490		' MAT D=ZER(N1)
3500 FOR I%=1 TO N1
3510    D(I%)=0
3520 NEXT I%
3530 FOR I%=1 TO N1
3540    FOR J%=1 TO N1
3550       IF (I%+J%)>2 GOTO 3580
3560       A(I%,J%)=DATAPTS%
3570       GOTO 3610
3580       FOR K%=1 TO DATAPTS%
3590          A(I%,J%)=A(I%,J%)+X(K%)^(I%+J%-2)
3600       NEXT K%
3610    NEXT J%
3620    FOR K%=1 TO DATAPTS%
3630       IF I%>1 GOTO 3660
3640       D(I%)=D(I%)+Y(K%)
3650       GOTO 3670
3660       D(I%)=D(I%)+Y(K%)*X(K%)^(I%-1)
3670    NEXT K%
3680 NEXT I%
3690		' SOLVE SIMULTANEOUS LINEAR EQUATIONS
3700		' MATRIX INVERT ROUTINE FOR MAT V=INV(A)
3710 FOR I%=1 TO N1
3720    FOR J%=1 TO N1
3730       V(I%,J%)=A(I%,J%)
3740    NEXT J%
3750 NEXT I%
3760 MM=N1-1
3770 FOR K%=1 TO N1
3780    U(K%)=0
3790    P=V(K%,1)
3800    IF P<>0 GOTO 3940
3810    FOR I%=K%+1 TO N1
3820       U(K%)=I%
3830       IF V(I%,1)=0 GOTO 3900
3840       FOR J%=1 TO N1
3850          R=V(K%,J%)
3860          V(K%,J%)=V(I%,J%)
3870          V(I%,J%)=R
3880       NEXT J%
3890       GOTO 3790
3900    NEXT I%
3910    PRINT: PRINT CHR$(7);"NO SOLUTION": PRINT 
3920    OFLAG%=1
3930    GOTO 2390
3940    FOR J%=1 TO MM
3950       V(K%,J%)=V(K%,J%+1)/P
3960    NEXT J%
3970    V(K%,N1)=1/P
3980    FOR I%=1 TO N1
3990       IF I%=K% GOTO 4050
4000       R=V(I%,1)
4010       FOR J%=1 TO MM
4020          V(I%,J%)=V(I%,J%+1)-R*V(K%,J%)
4030       NEXT J%
4040       V(I%,N1)=-R*V(K%,N1)
4050    NEXT I%
4060 NEXT K%
4070 FOR K%=MM TO 1 STEP -1
4080    U=U(K%)
4090    IF U=0 GOTO 4150
4100    FOR I%=1 TO N1
4110       R=V(I%,K%)
4120       V(I%,K%)=V(I%,J%)
4130       V(I%,J%)=R
4140    NEXT I%
4150 NEXT K%
4160		' MATRIX MULTIPLICATION ROUTINE FOR MAT C=V*D
4170 FOR I%=1 TO N1
4180    C(I%)=0
4190    FOR J%=1 TO N1
4200       C(I%)=C(I%)+V(I%,J%)*D(J%)
4210    NEXT J%
4220 NEXT I%
4230 RETURN
4240		' END CALCULATE
4250		' PRINT EQUATION FOR CURVE FIT
4260 C1=EXP(C(1))
4270 IF YFLAG%=1 THEN C1=-C1
4280 PRINT CHR$(26)
4290 IF NN=99 GOTO 4335
4300 IF N%=1 GOTO 4330
4310 PRINT: PRINT "POWER FUNCTION:  Y =";C1;"X^(";C(2);")"
4320 GOTO 4340
4330 PRINT: PRINT "EXPONENTIAL FUNCTION:  Y =";C1;"* e^(";C(2);"X )"
4332 GOTO 4340
4335 IF C(2)<0 THEN S$="-" ELSE S$="+"
4336 PRINT : PRINT "LOG FUNCTION:  Y =";C(1);S$;ABS(C(2));"(ln X)"
4337 PRINT 
4338 GOTO 4400
4340 PRINT
4350		' PRINT VALUES OF X AND Y AND CALCULATED VALUES OF Y
4360 FOR I%=1 TO DATAPTS%
4370    Y(I%)=EXP(Y(I%))
4380 NEXT I%
4390 IF N%=1 GOTO 4430
4400 FOR I%=1 TO DATAPTS%
4410    X(I%)=EXP(X(I%))
4420 NEXT I%
4430 E=0
4440 FOR I%=1 TO DATAPTS%
4445    IF NN=99 GOTO 4474
4450    IF N%=1 GOTO 4480
4460    YZ(I%)=C1*X(I%)^C(2)
4470    GOTO 4490
4474    YZ(I%)=C(1)+C(2)*LOG(X(I%))
4476    GOTO 4490
4480    YZ(I%)=C1*EXP(C(2)*X(I%))
4490    IF YFLAG%=1 THEN E=E+(-Y(I%)-YZ(I%))^2 ELSE E=E+(Y(I%)-YZ(I%))^2
4500 NEXT I%
4510 GOTO 1990
4520		' RESTORE ORIGINAL DATA
4530 FOR I%=1 TO DATAPTS%
4540    Y(I%)=YL(I%)
4550 NEXT I%
4560 GOTO 170

4510 GOTO 1990
4520		' RESTORE ORIGINAL DATA
4530 FOR I%