10 PRINT CHR$(26)
20 PRINT TAB(8);"LM3900FL DESIGNS AND ANALYZES ACTIVE FILTERS USING ONE OR MORE"
30 PRINT TAB(21);"SECTIONS OF AN LM3900 NORTON OP AMP."
35 PRINT 
36 PRINT TAB(8);STRING$(62,"*")
40 'Written by R. S. Stein, W6NBI, 4-9-86
50 'Suggested by LM3900.BAS by an unknown author, and based on
60 'National Semiconductor Application Note AN-72 (eq. nos in remarks)
65 PI=3.14159
70 PRINT : PRINT : PRINT
200 '---------------------------------------------------------------------------
210 PRINT "YOU HAVE THE FOLLOWING CHOICES:"
215 PRINT
220 PRINT "   1 - DESIGN A HIGH-PASS FILTER
230 PRINT "   2 - DESIGN A LOW-PASS FILTER
240 PRINT "   3 - DESIGN A BANDPASS FILTER WITH Q EQUAL TO OR LESS THAN 10
250 PRINT "   4 - DESIGN A BANDPASS FILTER WITH Q BETWEEN 10 AND 50
260 PRINT "   5 - DETERMINE CHARACTERISTICS OF A HIGH-PASS FILTER
270 PRINT "   6 - DETERMINE CHARACTERISTICS OF A LOW-PASS FILTER
280 PRINT "   7 - DETERMINE CHARACTERISTICS OF A SINGLE-SECTION BANDPASS FILTER
290 PRINT "   8 - DETERMINE CHARACTERISTICS OF A TWO-SECTION BANDPASS FILTER
295 PRINT "   0 - QUIT
300 PRINT 
310 INPUT "ENTER YOUR CHOICE ",V%
320 IF V%=0 THEN END
330 IF V%<1 OR V%>8 THEN PRINT "   Please enter a number between 1 and 8" : GOTO 300
335 PRINT CHR$(26)
340 ON V% GOTO 500,1000,1500,2000,2500,3000,3500,4000
499 '------------------------------------------------------------------------
500 PRINT "HIGH-PASS FILTER DESIGN
510 PRINT "=======================
520 PRINT 
530 INPUT "ENTER CUTOFF FREQUENCY IN Hz ",F
540 INPUT "ENTER PASSBAND VOLTAGE GAIN ",G
550 INPUT "ENTER Q ",Q
560 INPUT "ENTER STARTING VALUE FOR CAPACITORS IN uF ",C1
570 C3=C1
580 W=2*PI*F
590 R1=1/(Q*W*C1*.000001*(2*G+1))	'Eq. 1
600 R2=Q*(2*G+1)/(W*C1*.000001)		'Eq. 2
610 C2=C1/G				'Eq. 3
615 R3=R2
620 PRINT CHR$(26)
630 GOSUB 9170
640 PRINT 
650 INPUT "DO YOU WANT TO CHANGE THE VALUE OF A RESISTOR OR CAPACITOR? (Y/N)";C$
660 IF C$="Y" OR C$="y" THEN 680
670 INPUT "DO YOU WANT A PRINT-OUT OF THE CIRCUIT? (Y/N)";P$
673 IF P$="Y" OR P$="y" THEN GOSUB 9000
677 PRINT CHR$(26) : GOTO 200
680 INPUT "ENTER THE REFERENCE SYMBOL OF THE PART TO BE CHANGED ",D$
690 INPUT "ENTER THE NEW VALUE FOR THAT PART (DO NOT USE COMMAS) ",N
700 IF D$="R1" THEN J=R1/N : GOTO 735
710 IF D$="R2" THEN J=R2/N : GOTO 735
715 IF D$="R3" THEN R3=N : GOTO 620
720 IF D$="C1" OR D$="C3" THEN J=N/C1 : GOTO 735
730 IF D$="C2" THEN J=N/C2 : GOTO 735
732 PRINT "   You have entered an invalid reference symbol!" : GOTO 680
735 R1=R1/J : R2=R2/J : R3=R3/J : C1=C1*J : C2=C2*J : C3=C3*J
740 G=C1/C2
750 W=1/(R1*Q*C1*.000001*(2*G+1))
760 F=W/(2*PI)
770 GOTO 620
999 '------------------------------------------------------------------------
1000 PRINT "LOW-PASS FILTER DESIGN
1010 PRINT "======================
1020 PRINT 
1030 INPUT "ENTER CUTOFF FREQUENCY IN Hz ",F
1040 INPUT "ENTER PASSBAND VOLTAGE GAIN ",G
1050 INPUT "ENTER Q ",Q
1060 INPUT "ENTER STARTING VALUE FOR CAPACITORS IN uF ",C1
1062 INPUT "WILL THE FILTER BE AC OR DC COUPLED? (AC or DC)";A$
1064 IF A$<>"AC" AND A$<>"ac" AND A$<>"DC" AND A$<>"dc" THEN PRINT "   Please enter AC or DC" : GOTO 1062
1065 LPFLAG%=0
1070 W=2*PI*F
1080 K=1/(4*Q*Q*(G+1)) : GOTO 1085			 	        'Eq. 5A
1082 RESUME 1083			   'Reduce K if error in 1130
1083 K=.9*K
1085 IF LPFLAG%=0 THEN KX=K
1090 KK=1-4*K*Q*Q*(G+1)			   'Define term under radical in eq. 5
1100 ON ERROR GOTO 1082
1130 R2=(1+SQR(KK))/(2*Q*K*W*C1*.000001)				'Eq. 5
1140 R1=R2/G								'Eq. 4
1150 R3=1/((W*C1*.000001)^2*R2*K)					'Eq. 7
1160 IF A$="DC" OR A$="dc" THEN R4=2*(R1/2+R3) ELSE R4=2*(R2+R3)
1170 C2=K*C1								'Eq. 6
1180 PRINT CHR$(26)
1190 GOSUB 9500
1200 PRINT 
1210 PRINT "ALL RESISTANCES AND THE CAPACITANCE OF C2 CAN BE CHANGED
1220 PRINT "BY ENTERING A CHANGE FACTOR WHICH IS LESS THAN";KX
1230 INPUT "DO YOU WANT TO MAKE A CHANGE? (Y/N)";C$
1240 IF C$="Y" OR C$="y" THEN LPFLAG%=1 : GOTO 1250
1243 INPUT "DO YOU WANT A PRINT-OUT OF THE CIRCUIT? (Y/N)";P$
1245 IF P$="Y" OR P$="y" THEN GOSUB 9300
1248 PRINT CHR$(26) : GOTO 200
1250 INPUT "ENTER A FACTOR ",KN
1260 IF KN=<KX THEN K=KN ELSE PRINT "   Factor must be less than";KX : GOTO 1250
1270 GOTO 1090
1499 '------------------------------------------------------------------------
1500 PRINT "BANDPASS FILTER DESIGN (Q <= 10)
1510 PRINT "================================
1520 PRINT 
1530 INPUT "ENTER CENTER FREQUENCY IN Hz ",F
1540 INPUT "ENTER PASSBAND VOLTAGE GAIN ",G
1550 INPUT "ENTER Q ",Q
1560 INPUT "ENTER STARTING VALUE FOR CAPACITORS IN uF ",C1
1570 C2=C1
1580 W=2*PI*F
1590 R1=Q/(G*W*C1*.000001)		'Eq. 8
1600 R2=Q/((2*Q*Q-G)*W*C1*.000001)	'Eq. 9
1610 R3=2*Q/(W*C1*.000001)		'Eq. 10
1620 R4=2*R3				'Eq. 11
1630 PRINT CHR$(26)			
1640 GOSUB 9800
1645 PRINT
1650 INPUT "DO YOU WANT TO CHANGE THE VALUE OF A RESISTOR OR CAPACITOR? (Y/N)";C$
1660 IF C$="Y" OR C$="y" THEN 1680
1670 INPUT "DO YOU WANT A PRINT-OUT OF THE CIRCUIT? (Y/N)";P$
1673 IF P$="Y" OR P$="y" THEN GOSUB 9600
1677 PRINT CHR$(26) : GOTO 200
1680 INPUT "ENTER THE REFERENCE SYMBOL OF THE PART TO BE CHANGED ",D$
1690 INPUT "ENTER THE NEW VALUE FOR THAT PART (DO NOT USE COMMAS) ",N
1700 IF D$="R1" THEN J=R1/N : GOTO 1760
1710 IF D$="R2" THEN J=R2/N : GOTO 1760
1720 IF D$="R3" THEN J=R3/N : GOTO 1760
1730 IF D$="R4" THEN R4=N : GOTO 1630
1740 IF D$="C1" OR D$="C2" THEN J=N/C1 : GOTO 1760
1750 PRINT "   You have entered an invalid reference symbol!" : GOTO 1680
1760 R1=R1/J : R2=R2/J : R3=R3/J : R4=R4/J : C1=C1*J : C2=C2*J
1770 G=Q/(R1*W*C1*.000001)
1780 W=2*Q/(R3*C1*.000001)
1790 F=W/(2*PI)
1800 GOTO 1630
1999 '------------------------------------------------------------------------
2000 PRINT "BANDPASS FILTER DESIGN (10 >= Q =< 50)
2010 PRINT "======================================
2020 PRINT 
2025 FLAG%=0
2030 INPUT "ENTER CENTER FREQUENCY IN Hz ",F
2040 INPUT "ENTER Q ",Q
2050 INPUT "ENTER STARTING VALUE FOR CAPACITORS IN uF ",C1
2052 PRINT : PRINT "   AN INITIAL VOLTAGE GAIN WILL BE CALCULATED.
2054 PRINT "   YOU CAN ADJUST IT TO THE DESIRED GAIN SHORTLY.
2056 FOR X=1 TO 2500			'Delay loop
2058 NEXT 
2060 C2=C1
2070 W=2*PI*F
2100 K=5
2110 R1=Q/(W*C1*.000001)		'Eq. 12
2120 R4=R1 : R6=R1
2130 R2=R1*K*Q/(2*Q-1)			'Eq. 13
2140 R3=R1/(Q*Q-1-2/K+1/(K*Q))		'Eq. 14
2150 R7=K*R1				'Eq. 15
2160 G=K*SQR(Q)				'Eq. 16
2170 R5=2*R4
2180 R8=2*R6*R7/(R6+R7)
2190 GOSUB 11000
2200 PRINT 
2210 INPUT "DO YOU WANT TO CHANGE THE CALCULATED GAIN? (Y/N)";C$
2220 IF C$="Y" OR C$="y" THEN 2230
2222 INPUT "DO YOU WANT A PRINT-OUT OF THE CIRCUIT? (Y/N)";P$
2225 IF P$="Y" OR P$="y" THEN GOSUB 10000
2228 PRINT CHR$(26) : GOTO 200
2230 PRINT "YOU MAY ENTER A FACTOR BY WHICH THE GAIN SHOULD BE CHANGED.
2240 PRINT "BE SURE THAT YOU ARE REQUESTING A REALIZABLE GAIN.
2245 PRINT : INPUT "ENTER THE FACTOR (USE A DECIMAL < 1 TO REDUCE GAIN) ",GX
2250 K=K*GX
2260 GOTO 2110
2499 '-----------------------------------------------------------------------
2500 PRINT "HIGH-PASS FILTER ANALYSIS
2510 PRINT "=========================
2520 CLEAR
2530 PI=3.14159
2540 GOSUB 9170
2550 PRINT 
2555 I%=0
2560 PRINT "ENTER VALUES IN OHMS AND uF (C1=C3)
2570 INPUT "   1 - R1   ";R1 : IF I%<>0 THEN 2670
2580 INPUT "   2 - R2   ";R2 : IF I%<>0 THEN 2670
2585 PRINT "IF YOU ENTER ZERO FOR R3, THE PROGRAM WILL CALCULATE THE PROPER BIAS VALUE
2590 INPUT "   3 - R3   ";R3 : IF I%<>0 THEN 2670
2600 INPUT "   4 - C1,C3";C1 : IF I%<>0 THEN 2670
2610 INPUT "   5 - C2   ";C2 : IF I%<>0 THEN 2670
2620 PRINT 
2630 INPUT "ARE THERE ANY CORRECTIONS TO THE ABOVE? (Y/N)";C$
2640 IF C$="N" OR C$="n" THEN 2690
2650 INPUT "ENTER THE LINE NUMBER TO BE CHANGED ",I%
2652 IF I%<1 OR I%>5 THEN PRINT "   Please enter a number between 1 and 5" : GOTO 2650
2660 ON I% GOTO 2570,2580,2590,2600,2610
2670 INPUT "ANY MORE CHANGES? (Y/N)";C$
2680 GOTO 2640
2690 C3=C1
2700 G=C1/C2
2800 W=SQR(1/(R1*R2*(C1*.000001)^2))
2810 F=W/(2*PI)
2820 Q=1/(R1*W*C1*.000001*(2*G+1))
2825 IF R3=0 THEN R3=R2
2830 PRINT CHR$(26)
2840 GOSUB 9170
2850 GOSUB 15000
2860 IF C$="Y" OR C$="y" THEN 2910
2870 INPUT "DO YOU WANT A PRINT-OUT OF THE CIRCUIT? (Y/N)";P$
2880 IF P$="Y" OR P$="y" THEN GOSUB 9000
2890 PRINT CHR$(26) : GOTO 200
2910 IF RS$="R1" THEN R1=N : GOTO 2800
2920 IF RS$="R2" THEN R2=N : GOTO 2800
2930 IF RS$="R3" THEN R3=N : GOTO 2825
2940 IF RS$="C1" OR RS$="C3" THEN C1=N : GOTO 2690
2950 IF RS$="C2" THEN C2=N : GOTO 2700
2960 PRINT "   You have entered an invalid reference symbol!" : GOSUB 15040
2970 GOTO 2910
2999 '--------------------------------------------------------------------------
3000 PRINT "LOW-PASS FILTER ANALYSIS
3010 PRINT "========================
3020 CLEAR
3030 PI=3.14159
3040 GOSUB 9500
3050 PRINT 
3055 I%=0
3060 PRINT "ENTER VALUES IN OHMS AND uF
3070 INPUT "   1 - R1";R1 : IF I%<>0 THEN 3170
3080 INPUT "   2 - R2";R2 : IF I%<>0 THEN 3170
3090 INPUT "   3 - R3";R3 : IF I%<>0 THEN 3170
3092 PRINT "IF YOU ENTER ZERO FOR R4, THE PROGRAM WILL CALCULATE THE PROPER BIAS VALUE
3095 INPUT "   4 - R4";R4 : IF I%<>0 THEN 3170
3100 INPUT "   5 - C1";C1 : IF I%<>0 THEN 3170
3110 INPUT "   6 - C2";C2 : IF I%<>0 THEN 3170
3120 PRINT 
3130 INPUT "ARE THERE ANY CORRECTIONS TO THE ABOVE? (Y/N)";C$
3140 IF C$="N" OR C$="n" THEN 3190
3150 INPUT "ENTER THE LINE NUMBER TO BE CHANGED ",I%
3155 IF I%<1 OR I%>6 THEN PRINT "   Please enter a number between 1 and 6" : GOTO 3150
3160 ON I% GOTO 3070,3080,3090,3095,3100,3110
3170 INPUT "ANY MORE CHANGES? (Y/N)";C$
3180 GOTO 3140
3190 K=C2/C1
3260 G=R2/R1
3270 W=SQR(1/((C1*.000001)^2*R2*R3*K))
3280 F=W/(2*PI)
3290 Z=G+1
3300 Q=SQR(1/(4*K*Z))
3310 IF R4=0 THEN R4=2*(R1/2+R3)
3330 PRINT CHR$(26)
3340 GOSUB 9500
3350 GOSUB 15000
3360 IF C$="Y" OR C$="y" THEN 3410
3370 INPUT "DO YOU WANT A PRINT-OUT OF THE CIRCUIT? (Y/N)";P$
3380 IF P$="Y" OR P$="y" THEN GOSUB 9300
3390 PRINT CHR$(26) : GOTO 200
3410 IF RS$="R1" THEN R1=N : GOTO 3260
3420 IF RS$="R2" THEN R2=N : GOTO 3260
3430 IF RS$="R3" THEN R3=N : GOTO 3260
3440 IF RS$="R4" THEN R4=N : GOTO 3310
3450 IF RS$="C1" THEN C1=N : GOTO 3190
3460 IF RS$="C2" THEN C2=N : GOTO 3190
3470 PRINT "   You have entered an invalid reference symbol!" : GOSUB 15040
3480 GOTO 3410
3499 '--------------------------------------------------------------------------
3500 PRINT "SINGLE-SECTION BANDPASS FILTER ANALYSIS
3510 PRINT "=======================================
3520 CLEAR
3530 PI=3.14159
3540 GOSUB 9800
3550 PRINT 
3555 I%=0
3560 PRINT "ENTER VALUES IN OHMS AND uF (C1=C2)
3570 INPUT "   1 - R1   ";R1 : IF I%<>0 THEN 3670
3580 INPUT "   2 - R2   ";R2 : IF I%<>0 THEN 3670
3590 INPUT "   3 - R3   ";R3 : IF I%<>0 THEN 3670
3595 PRINT "IF YOU ENTER ZERO FOR R4, THE PROGRAM WILL CALCULATE THE PROPER BIAS VALUE
3600 INPUT "   4 - R4   ";R4 : IF I%<>0 THEN 3670
3610 INPUT "   5 - C1,C2";C1 : IF I%<>0 THEN 3670
3620 PRINT 
3630 INPUT "ARE THERE ANY CORRECTIONS TO THE ABOVE? (Y/N)";C$
3640 IF C$="N" OR C$="n" THEN 3690
3650 INPUT "ENTER THE LINE NUMBER TO BE CHANGED ",I%
3652 IF I%<1 OR I%>5 THEN PRINT "   Please enter a number between 1 and 5" : GOTO 3650
3660 ON I% GOTO 3570,3580,3590,3600,3610
3670 INPUT "ANY MORE CHANGES? (Y/N)";C$
3680 GOTO 3640
3690 C2=C1
3700 G=R3/(2*R1)
3710 Q=SQR(R1*G/(2*R2)+G/2)
3720 W=2*Q/(R3*C1*.000001)
3730 F=W/(2*PI)
3740 IF R4=0 THEN R4=2*R3
3750 PRINT CHR$(26)
3760 GOSUB 9800
3770 GOSUB 15000
3780 IF C$="Y" OR C$="y" THEN 3810
3790 INPUT "DO YOU WANT A PRINT-OUT OF THE CIRCUIT? (Y/N)";P$
3800 IF P$="Y" OR P$="y" THEN GOSUB 9600
3805 PRINT CHR$(26) : GOTO 200
3810 IF RS$="R1" THEN R1=N : GOTO 3700
3820 IF RS$="R2" THEN R2=N : GOTO 3700
3830 IF RS$="R3" THEN R3=N : GOTO 3700
3840 IF RS$="R4" THEN R4=N : GOTO 3740
3850 IF RS$="C1" OR RS$="C2" THEN C1=N : GOTO 3690
3860 PRINT "   You have entered an invalid reference symbol!" : GOSUB 15040
3870 GOTO 3810
3999 '--------------------------------------------------------------------------
4000 PRINT "TWO-SECTION BANDPASS FILTER ANALYSIS
4010 PRINT "====================================
4020 CLEAR
4025 I%=0 : R2FLAG%=0 : BPFLAG%=1
4030 PI=3.14159
4040 GOSUB 11000
4050 PRINT 
4060 PRINT "ENTER VALUES IN OHMS AND uF (R1=R4=R6 AND C1=C2)
4070 INPUT "   1 - R1,R4,R6";R1 : IF I%<>0 THEN 4170
4075 INPUT "   2 - R2      ";R2 : IF I%<>0 THEN 4170
4080 INPUT "   3 - R3      ";R3 : IF I%<>0 THEN 4170
4082 PRINT "IF YOU ENTER ZERO FOR R5, THE PROGRAM WILL CALCULATE THE PROPER BIAS VALUE
4085 INPUT "   4 - R5      ";R5 : IF I%<>0 THEN 4170
4090 INPUT "   5 - R7      ";R7 : IF I%<>0 THEN 4170
4092 PRINT "IF YOU ENTER ZERO FOR R8, THE PROGRAM WILL CALCULATE THE PROPER BIAS VALUE
4100 INPUT "   6 - R8      ";R8 : IF I%<>0 THEN 4170
4110 INPUT "   7 - C1,C2   ";C1 : IF I%<>0 THEN 4170
4120 PRINT 
4130 INPUT "ARE THERE ANY CORRECTIONS TO THE ABOVE? (Y/N)";C$
4140 IF C$="N" OR C$="n" THEN 4190
4150 INPUT "ENTER THE LINE NUMBER TO BE CHANGED ",I%
4155 IF I%<1 OR I%>7 THEN PRINT "   Please enter a number between 1 and 7" : GOTO 4150
4160 ON I% GOTO 4070,4075,4080,4085,4090,4100,4110
4170 INPUT "ANY MORE CHANGES? (Y/N)";C$
4180 GOTO 4140
4190 R4=R1 : R6=R1 : C2=C1
4200 K=R7/R1
4210 QR=R2/(2*R2-K*R1)
4220 Q=(-1/K+SQR(1/K^2+4*(R1/R3+2/K)))/2
4230 IF QR<.95*Q OR QR>1.05*Q THEN R2FLAG%=1
4240 G=K*SQR(Q)
4250 W=Q/(R1*C1*.000001) 
4260 F=W/(2*PI)
4270 IF R5=0 THEN R5=2*R4
4280 IF R8=0 THEN R8=2*R6*R7/(R6+R7)
4290 BPFLAG%=0
4330 PRINT CHR$(26)
4340 GOSUB 11000
4345 IF R2FLAG%=1 THEN PRINT "R2 IS NOT OPTIMUM FOR CALCULATED VALUE OF Q
4350 GOSUB 15000
4360 IF C$="Y" OR C$="y" THEN 4410
4370 INPUT "DO YOU WANT A PRINT-OUT OF THE CIRCUIT? (Y/N)";P$
4380 IF P$="Y" OR P$="y" THEN GOSUB 10000
4390 PRINT CHR$(26) : GOTO 200
4410 IF RS$="R1" OR RS$="R4" OR RS$="R6" THEN R1=N : GOTO 4190
4420 IF RS$="R2" THEN R2=N : GOTO 4210
4430 IF RS$="R3" THEN R3=N : GOTO 4230
4440 IF RS$="R5" THEN R5=N : GOTO 4270
4445 IF RS$="R7" THEN R7=N : GOTO 4200
4450 IF RS$="R8" THEN R8=N : GOTO 4280
4460 IF RS$="C1" OR RS$="C2" THEN C1=N : GOTO 4190
4470 PRINT "   You have entered an invalid reference symbol!" : GOSUB 15040
4480 GOTO 4410
9000 '------------------------------------------------------------------------
9005 LPRINT "                          C2";TAB(50);USING "R1 = ##,###,### OHMS";R1
9010 LPRINT "             +------------||-----------+"
9020 LPRINT "             |                 R2      |";TAB(50);USING "R2 = ##,###,### OHMS";R2
9030 LPRINT "             |          +----/\/\/\----+"
9040 LPRINT "             |          |  |\          |";TAB(50);USING "R3 = ##,###,### OHMS";R3
9050 LPRINT "             |          |  |  \        |"
9060 LPRINT "IN ----||----+----||----+--|-   \      |";TAB(50);USING "C1 = #.###### uF";C1
9070 LPRINT "       C1    |    C3       | HIGH \    |"
9080 LPRINT "             >             |        >--+-- OUT";TAB(50);USING "C2 = #.###### uF";C2
9090 LPRINT "             < R1          | PASS /"
9100 LPRINT "             >          ---|+   /";TAB(50);USING "C3 = #.###### uF";C3
9110 LPRINT "             |          |  |  /"
9120 LPRINT "            ---         >  |/";TAB(50);"Fc =";F; "Hz" 
9130 LPRINT "            ///      R3 <"
9140 LPRINT "                        >";TAB(50);"Av =";G
9150 LPRINT "                        |"
9160 LPRINT "                      V+ / 2";TAB(50);"Q  =";Q
9165 RETURN
9170 '------------------------------------------------------------------------
9175 PRINT "                          C2";TAB(50);USING "R1 = ##,###,### OHMS";R1
9180 PRINT "             +------------||-----------+"
9185 PRINT "             |                 R2      |";TAB(50);USING "R2 = ##,###,### OHMS";R2
9190 PRINT "             |          +----/\/\/\----+"
9195 PRINT "             |          |  |\          |";TAB(50);USING "R3 = ##,###,### OHMS";R3
9200 PRINT "             |          |  |  \        |"
9205 PRINT "IN ----||----+----||----+--|-   \      |";TAB(50);USING "C1 = #.###### uF";C1
9210 PRINT "       C1    |    C3       | HIGH \    |"
9215 PRINT "             >             |        >--+-- OUT";TAB(50);USING "C2 = #.###### uF";C2
9220 PRINT "             < R1          | PASS /"
9225 PRINT "             >          ---|+   /";TAB(50);USING "C3 = #.###### uF";C3
9230 PRINT "             |          |  |  /"
9235 PRINT "            ---         >  |/";TAB(50);"Fc =";F; "Hz" 
9240 PRINT "            ///      R3 <"
9245 PRINT "                        >";TAB(50);"Av =";G
9250 PRINT "                        |"
9255 PRINT "                      V+ / 2";TAB(50);"Q  =";Q
9260 RETURN
9300 '------------------------------------------------------------------------
9305 LPRINT "                          R2";TAB(50);USING "R1 = ##,###,### OHMS";R1
9310 LPRINT "             +----------/\/\/\---------+"
9320 LPRINT "             |                 C2      |";TAB(50);USING "R2 = ##,###,### OHMS";R2
9330 LPRINT "             |          +------||------+"
9340 LPRINT "             |          |  |\          |";TAB(50);USING "R3 = ##,###,### OHMS";R3
9350 LPRINT "             |          |  |  \        |"
9360 LPRINT "IN --/\/\/\--+--/\/\/\--+--|-   \      |";TAB(50);USING "R4 = ##,###,### OHMS";R4
9370 LPRINT "       R1    |    R3       | LOW  \    |"
9380 LPRINT "            ---            |        >--+-- OUT";TAB(50);USING "C1 = #.###### uF";C1
9390 LPRINT "            --- C1         | PASS /"
9400 LPRINT "             |          ---|+   /";TAB(50);USING "C2 = #.###### uF";C2
9410 LPRINT "            ---         |  |  /"
9420 LPRINT "            ///         >  |/";TAB(50);"Fc =";F; "Hz" 
9430 LPRINT "                     R4 <"
9440 LPRINT "                        >";TAB(50);"Av =";G
9450 LPRINT "                        |"
9460 LPRINT "                        V+";TAB(50);"Q  =";Q
9470 RETURN
9500 '------------------------------------------------------------------------
9505 PRINT "                          R2";TAB(50);USING "R1 = ##,###,### OHMS";R1
9510 PRINT "             +----------/\/\/\---------+"
9515 PRINT "             |                 C2      |";TAB(50);USING "R2 = ##,###,### OHMS";R2
9520 PRINT "             |          +------||------+"
9525 PRINT "             |          |  |\          |";TAB(50);USING "R3 = ##,###,### OHMS";R3
9530 PRINT "             |          |  |  \        |"
9535 PRINT "IN --/\/\/\--+--/\/\/\--+--|-   \      |";TAB(50);USING "R4 = ##,###,### OHMS";R4
9540 PRINT "       R1    |    R3       | LOW  \    |"
9545 PRINT "            ---            |        >--+-- OUT";TAB(50);USING "C1 = #.###### uF";C1
9550 PRINT "            --- C1         | PASS /"
9555 PRINT "             |          ---|+   /";TAB(50);USING "C2 = #.###### uF";C2
9560 PRINT "            ---         |  |  /"
9565 PRINT "            ///         >  |/";TAB(50);"Fc =";F; "Hz" 
9570 PRINT "                     R4 <"
9575 PRINT "                        >";TAB(50);"Av =";G
9580 PRINT "                        |"
9585 PRINT "                        V+";TAB(50);"Q  =";Q
9590 RETURN
9600 '------------------------------------------------------------------------
9605 LPRINT "                          C1";TAB(50);USING "R1 = ##,###,### OHMS";R1
9610 LPRINT "             +------------||-----------+"
9620 LPRINT "             |                 R3      |";TAB(50);USING "R2 = ##,###,### OHMS";R2
9630 LPRINT "             |          +----/\/\/\----+"
9640 LPRINT "             |          |  |\          |";TAB(50);USING "R3 = ##,###,### OHMS";R3
9650 LPRINT "             |          |  |  \        |"
9660 LPRINT "IN --/\/\/\--+----||----+--|-   \      |";TAB(50);USING "R4 = ##,###,### OHMS";R4
9670 LPRINT "       R1    |    C2       | BAND \    |"
9680 LPRINT "             >             |        >--+-- OUT";TAB(50);USING "C1 = #.###### uF";C1
9690 LPRINT "             < R2          | PASS /"
9700 LPRINT "             >          ---|+   /";TAB(50);USING "C2 = #.###### uF";C2
9710 LPRINT "             |          |  |  /"
9720 LPRINT "            ---         >  |/";TAB(50);"Fo =";F; "Hz" 
9730 LPRINT "            ///      R4 <"
9740 LPRINT "                        >";TAB(50);"Av =";G
9750 LPRINT "                        |"
9760 LPRINT "                        V+"TAB(50);"Q  =";Q
9780 RETURN
9800 '------------------------------------------------------------------------
9805 PRINT "                          C1";TAB(50);USING "R1 = ##,###,### OHMS";R1
9810 PRINT "             +------------||-----------+"
9820 PRINT "             |                 R3      |";TAB(50);USING "R2 = ##,###,### OHMS";R2
9830 PRINT "             |          +----/\/\/\----+"
9840 PRINT "             |          |  |\          |";TAB(50);USING "R3 = ##,###,### OHMS";R3
9850 PRINT "             |          |  |  \        |"
9860 PRINT "IN --/\/\/\--+----||----+--|-   \      |";TAB(50);USING "R4 = ##,###,### OHMS";R4
9870 PRINT "       R1    |    C2       | BAND \    |"
9880 PRINT "             >             |        >--+-- OUT";TAB(50);USING "C1 = #.###### uF";C1
9890 PRINT "             < R2          | PASS /"
9900 PRINT "             >          ---|+   /";TAB(50);USING "C2 = #.###### uF";C2
9910 PRINT "             |          |  |  /"
9920 PRINT "            ---         >  |/";TAB(50);"Fo =";F; "Hz" 
9930 PRINT "            ///      R4 <"
9940 PRINT "                        >";TAB(50);"Av =";G
9950 PRINT "                        |"
9960 PRINT "                        V+"TAB(50);"Q  =";Q
9980 RETURN
10000 '-----------------------------------------------------------------------
10010 LPRINT "             +------------------------/\/\/\-------------------+
10020 LPRINT "             |           C1             R2                     |
10030 LPRINT "             +-----------||----------+                         |
10040 LPRINT "             |               R4      |                 R7      |
10050 LPRINT "             |        +----/\/\/\----+          +----/\/\/\----+
10060 LPRINT "             |        |  |\          |          |  |\          |
10070 LPRINT "             |        |  |  \        |          |  |  \        |
10080 LPRINT "IN --/\/\/\--+---||---+--|-   \      +--/\/\/\--+--|-   \      |
10090 LPRINT "       R1    |   C2      |      \    |    R6       |      \    |
10100 LPRINT "             >           |        >--+             |        >--+-- OUT
10110 LPRINT "             < R3        |      /                  |      /
10120 LPRINT "             >        ---|+   /    BANDPASS     ---|+   /   
10130 LPRINT "             |        |  |  /                   |  |  / 
10140 LPRINT "            ---       >  |/                     >  |/";TAB(60);"Fo =";F;"Hz"
10150 LPRINT "            ///    R5 <                      R8 <";TAB(60);"Av =";G
10160 LPRINT "                      >                         >";TAB(60);"Q  =";Q
10170 LPRINT "                      |                         |
10180 LPRINT "                      V+                        V+
10200 IF BPFLAG%=1 THEN RETURN
10210 LPRINT USING "C1 = #.###### uF";C1; 
10220 LPRINT TAB(28);USING "R1 = ##,###,### OHMS";R1; 
10230 LPRINT TAB(60);USING "R5 = ##,###,### OHMS";R5 
10240 LPRINT USING "C2 = #.###### uF";C2; 
10250 LPRINT TAB(28);USING "R2 = ##,###,### OHMS";R2; 
10260 LPRINT TAB(60);USING "R6 = ##,###,### OHMS";R6
10280 LPRINT TAB(28);USING "R3 = ##,###,### OHMS";R3;
10290 LPRINT TAB(60);USING "R7 = ##,###,### OHMS";R7
10310 LPRINT TAB(28);USING "R4 = ##,###,### OHMS";R4;
10320 LPRINT TAB(60);USING "R8 = ##,###,### OHMS";R8
10340 RETURN
11000 '-----------------------------------------------------------------------
11010 PRINT "             +------------------------/\/\/\-------------------+
11020 PRINT "             |           C1             R2                     |
11030 PRINT "             +-----------||----------+                         |
11040 PRINT "             |               R4      |                 R7      |
11050 PRINT "             |        +----/\/\/\----+          +----/\/\/\----+
11060 PRINT "             |        |  |\          |          |  |\          |
11070 PRINT "             |        |  |  \        |          |  |  \        |
11080 PRINT "IN --/\/\/\--+---||---+--|-   \      +--/\/\/\--+--|-   \      |
11090 PRINT "       R1    |   C2      |      \    |    R6       |      \    |
11100 PRINT "             >           |        >--+             |        >--+-- OUT
11110 PRINT "             < R3        |      /                  |      /
11120 PRINT "             >        ---|+   /    BANDPASS     ---|+   /   
11130 PRINT "             |        |  |  /                   |  |  / 
11140 PRINT "            ---       >  |/                     >  |/";TAB(60);"Fo =";F;"Hz"
11150 PRINT "            ///    R5 <                      R8 <";TAB(60);"Av =";G
11160 PRINT "                      >                         >";TAB(60);"Q  =";Q
11170 PRINT "                      |                         |
11180 PRINT "                      V+                        V+
11200 IF BPFLAG%=1 THEN RETURN
11210 PRINT USING "C1 = #.###### uF";C1; 
11220 PRINT TAB(28);USING "R1 = ##,###,### OHMS";R1; 
11230 PRINT TAB(60);USING "R5 = ##,###,### OHMS";R5 
11240 PRINT USING "C2 = #.###### uF";C2; 
11250 PRINT TAB(28);USING "R2 = ##,###,### OHMS";R2; 
11260 PRINT TAB(60);USING "R6 = ##,###,### OHMS";R6
11280 PRINT TAB(28);USING "R3 = ##,###,### OHMS";R3;
11290 PRINT TAB(60);USING "R7 = ##,###,### OHMS";R7
11310 PRINT TAB(28);USING "R4 = ##,###,### OHMS";R4;
11320 PRINT TAB(60);USING "R8 = ##,###,### OHMS";R8
11340 RETURN
15000 '------------------------------------------------------------------------
15010 IF R2FLAG%<>1 THEN PRINT : PRINT 
15020 INPUT "DO YOU WANT TO CHANGE THE VALUE OF A RESISTOR OR CAPACITOR? (Y/N)";C$
15030 IF C$<>"Y" AND C$<>"y" THEN RETURN
15040 INPUT "ENTER THE REFERENCE SYMBOL ",RS$
15050 INPUT "ENTER THE NEW VALUE ",N
15055 RETURN
15060 '------------------------------------------------------------------------
20010 'LM3900FL.BAS
VALUE ",N
15055 RETURN
15060 '--------------------