/*
%CC1 $1.C -X -E5000
%CLINK $1 DIO WILDEXP -S
%DELETE $1.CRL 
*/
/*********************************************************************
*                               BATCH                                *
**********************************************************************
*                  COPYRIGHT 1983 EUGENE H. MALLORY                  *
*********************************************************************/
#INCLUDE "BDSCIO.H"
#INCLUDE "DIO.H"
#DEFINE BCOUNT 120
CHAR string[MAXLINE];
CHAR fname[MAXLINE];
CHAR c;
INT fd1,fd2;
CHAR fcb1[BUFSIZ],fcb2[BUFSIZ];
CHAR barray[BCOUNT][MAXLINE];
CHAR buffer[128];
INT bctr,flag;
INT string_compare();

MAIN(argc,argv)
CHAR **argv;
INT argc;

BEGIN
    INT i,j,menuflag;
    CHAR *fvector[3];
    CHAR **fvectorp;
    CHAR *disk;
    INT diskno,vctr,len;
    
    dioinit(&argc,argv);
    
    IF (DIOIN)
	BEGIN
	    bctr = 0;
	    WHILE (!getstring(string))
		BEGIN
		    len = strlen(string);
		    string[len-1] = 0;
		    linecopy(barray[bctr++],string,argv,argc,0); 
		    IF (bctr == BCOUNT)
			error("BATCH: Batch file too big.");
		END
	    goto writesub;
	END


    IF (argc >= 2 && argv[1][0] == '/')
	BEGIN
	    bctr = 0;
	    typef("*");
	    WHILE (gets(string))
		BEGIN
		    IF (string[0] == 0) goto writesub;
		    linecopy(barray[bctr++],string,argv,argc,1); 
		    IF (bctr == BCOUNT)
			error("BATCH: Batch file too big.");
		    typef("*");
		END
	    goto writesub;
	END
	
    IF (argc < 2)
	BEGIN
	    disk = "ABCDEFGHIJKL";
	    vctr = 3;
	    diskno = BDOS(25);
	    IF (!diskno) vctr = 2;
	    fvector[0] = "DUMMY";
	    fvector[1] = "?:*.BAT";
	    fvector[1][0] = disk[diskno];
	    fvector[2] = "A:*.BAT";
	    fvectorp = fvector;
	    wildexp(&vctr,&fvectorp);
	    qsort(&fvectorp[1],vctr-1,2,&string_compare); 
	    fvectorp++;
filemenu:
	    i = menu(vctr-1,fvectorp);
	    IF (i == -1) goto exitbatch;
	    strcpy(fname,fvectorp[i]);
	    fd1 = fopen(fname,fcb1);
	    IF (fd1 == ERROR)
		error("BATCH: Unable to open %s",fname);
	END
    ELSE
	BEGIN
	    strcpy(fname,argv[1]);
	    strcat(fname,".BAT");
	    fd1 = fopen(fname,fcb1);
	    IF (fd1==ERROR) 
		BEGIN
		    strcpy(fname,"a:");
		    strcat(fname,argv[1]);
		    strcat(fname,".BAT");
		    fd1 = fopen(fname,fcb1);
		END
	    IF (fd1==ERROR) 
		BEGIN
		    dioflush();
		    error("BATCH: Unable to find: %s. \N",fname);
		END
	END
	
    IF (!fgets(string,fcb1))
	BEGIN
	    dioflush();
	    error("BATCH: Batch file %s empty.",fname);
	END
	
    bctr = 0;
    DO
	BEGIN
	    len = strlen(string);
	    string[len-1] = 0;
	    linecopy(barray[bctr++],string,argv,argc,1); 
	    IF (bctr == BCOUNT)
		error("BATCH: Batch file too big.");
	END
    WHILE (fgets(string,fcb1));
	
/*	SUBSTITUTED ARGUMENTS ARE NOW IN BARRAY */    

writesub:    
    fd2 = open("A:$$$.SUB",2);
    IF (fd2 == -1)
	BEGIN
	    fd2 = creat("A:$$$.SUB");
	END
    ELSE
	BEGIN
	    DO
		BEGIN
		    flag = read(fd2,buffer,1);
		    IF (flag == -1)
			error("BATCH: Unable to append to A:$$$.SUB.");
		END
	    WHILE (flag);
	END
    
    /* Now $$.sub should be opened correctly */
    
    WHILE (bctr--)
	BEGIN
	    FOR (i=0;i<128;i++) buffer[i] = 0x1a;
	    strcpy(&buffer[1],barray[bctr]);
	    buffer[0] = strlen(barray[bctr]);
	    i = write(fd2,buffer,1);
	    IF (i != 1)
		error("BATCH: Unable to write A:$$$.SUB.");
	END
    close(fd2);
    
exitbatch:
    dioflush();
    bios(1);
END

menu(icounter,strings)
CHAR **strings;
INT icounter;
BEGIN
INT max,bias,i,j;
CHAR *prompt;
    prompt = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    bias = 0;
loop:
    typef("\n\014");
    IF ((icounter-bias) > 26) max = 26;
    ELSE max = icounter-bias;
    FOR (i=0;i<(max+1)/2;i++)
	BEGIN
	    typef("%c) %s",prompt[i],strings[i+bias]);
	    IF (i+bias+(max+1)/2 < icounter)
		BEGIN
		    FOR (j=0;j<=37-strlen(strings[i+bias]);j++) typef(" ");
		    typef("%c) %s\n",
			prompt[i+(max+1)/2],
			strings[i+bias+(max+1)/2]);
		END
	    ELSE typef("\n");
	END
    typef("\n\n");
    IF (icounter > bias+26)
	typef("More selections are available.\n");
    typef("Type selection, ESC to exit, CR for more, - to backup :");
    c = bdos(1);
    typef("\n\014");
    IF (c == '\033') RETURN -1;
    IF (c == '\r' && (icounter > bias+26)) bias += 26;
    ELSE IF (c == '\r' && (icounter <= bias+26)) bias = 0;
    IF (c == '-') bias -= 26;
    IF (bias < 0) bias = 0;
    IF (!isalpha(c)) goto loop;
    FOR (i=0;toupper(c)!=prompt[i];i++);
    IF (i>=max) goto loop;
    IF (i+bias >= icounter) goto loop;
    RETURN i+bias;
END

INT string_compare(s,t)
CHAR **s, **t;
BEGIN
    CHAR *s1, *t1;
    INT i;
    s1 = *s;
    t1 = *t;
	FOR (i=0;i<MAXLINE;i++)
	    BEGIN
		IF (t1[i] != s1[i]) 
		    RETURN s1[i] - t1[i];
		IF (s1[i] == '\0')  RETURN 0;
	    END
	RETURN 0;
END

linecopy(dest,source,argv,argc,bias)
CHAR *dest,*source,**argv;
INT argc,bias;
BEGIN
INT i;
CHAR c,tempstr[MAXLINE];
    IF (*source == '*') *source = ';';
    WHILE (c = *source++)    
	BEGIN
	    IF (c == '$' && isdigit(*source))
		BEGIN
		    i = *source-'0'+bias;
		    IF (i < argc)
			BEGIN
			    strcpy(dest,argv[i]);
			    dest += strlen(argv[i]);
			END
		    source++;
		END
	    ELSE IF (c == '$' && *source == '*')
		BEGIN
		    FOR (i=1+bias;i<argc;i++)
			BEGIN
			    IF (i < argc)
				BEGIN
				    strcpy(dest,argv[i]);
				    strcat(dest," ");
				    dest += strlen(argv[i])+1;
				END
			END
		    source++;
		END
	    ELSE IF (c == '$' && *source == '#')
		BEGIN
		    sprintf(tempstr,"%d",argc-bias);
		    strcpy(dest,tempstr);
		    dest += strlen(tempstr);
		    source++;
		END
	    ELSE IF (c == '$' && *source == '$')
		BEGIN
		    source++;
		    *dest++ = c;
		END
	    ELSE IF (c == '^' && isalpha(*source))
		BEGIN
		    *dest++ = toupper(*source)-0x40;
		    source++;
		END 
	    ELSE
		BEGIN
		    *dest++ = c;
		END
	END
    *dest = 0;
END

