/*
%CC1 $1.C -X -e5000
%CLINK $1 DIO -S
%DELETE $1.CRL
*/
/*******************************************************************
*                            CASE                                  *
********************************************************************
*                 COPYRIGHT 1983 EUGENE H. MALLORY                 *
*******************************************************************/

#INCLUDE "bdscio.h"
#INCLUDE "dio.h"

#DEFINE MAXNAMES 40
    
INT lastchar;

main(argc,argv)

CHAR **argv;
INT argc;

  BEGIN
    CHAR word[2000];
    CHAR delimiter[1];
    INT c;
    INT flag;
    INT i;

    CHAR *keyword[MAXNAMES];
    INT  keycount[MAXNAMES];
    
    i = 0;
    keyword[i++] = "MAIN";
    keyword[i++] = "FUNCTION";
    keyword[i++] = "CHAR";
    keyword[i++] = "INT";
    keyword[i++] = "REGISTER";
    keyword[i++] = "STRUCT";
    keyword[i++] = "UNION";
    keyword[i++] = "UNSIGNED";
    keyword[i++] = "BEGIN";
    keyword[i++] = "END";
    keyword[i++] = "BREAK";
    keyword[i++] = "CONTINUE";
    keyword[i++] = "DEFAULT";
    keyword[i++] = "IF";
    keyword[i++] = "THEN";
    keyword[i++] = "ELSE";
    keyword[i++] = "ENDIF";
    keyword[i++] = "GOTO";
    keyword[i++] = "DO";
    keyword[i++] = "FOR";
    keyword[i++] = "WHILE";
    keyword[i++] = "LOOP";
    keyword[i++] = "ENDLOOP";
    keyword[i++] = "RETURN";
    keyword[i++] = "SIZEOF";
    keyword[i++] = "SWITCH";
    keyword[i++] = "CASE";
    keyword[i++] = "DEFINE";
    keyword[i++] = "IFDEF";
    keyword[i++] = "IFNDEF";
    keyword[i++] = "UNDEF";
    keyword[i++] = "INCLUDE";
    keyword[i++] = "$$$";
    

    lastchar = 0;
    FOR (i=0;i<MAXNAMES;i++) keycount[i] = 0;

    dioinit(&argc,argv);
    DO
      LOOP
	flag = get_word(word,delimiter);
	FOR (i=0;i<MAXNAMES;i++)
	  LOOP
	    IF (strequ(keyword[i],"$$$"))
	    BREAK;
	    IF (strequ(keyword[i],word))
	      THEN
		keycount[i]++;
		upper_case(word);
		BREAK;
	      ENDIF
	  ENDLOOP
	puts(word);
	IF (flag)
	putchar(delimiter[0]);
      ENDLOOP
    WHILE (flag);
    
	FOR (i=0;i<MAXNAMES;i++)
	  LOOP
	    IF (strequ(keyword[i],"$$$"))
	    BREAK;
	    IF (keycount[i])
	      THEN
		typef("%7d %ss\n",keycount[i],keyword[i]);
	      ENDIF
	  ENDLOOP
    dioflush();
  END

FUNCTION get_word(cptr,dptr)
CHAR *cptr,*dptr;
  BEGIN
    INT c;
    INT nest;

    nest = 0;
lup:
    c = getchar();
    IF (c == EOF)
      THEN
	*cptr++ = 0;
	*dptr = CPMEOF;
	RETURN 0;
      ENDIF
    IF (lastchar == '/' && c == '*')
      THEN
	lastchar = 0;  	/* LOUSE IT UP SO NESTS WORK */
	WHILE ((c != '/') || (lastchar != '*') || (nest > 0))
	  LOOP
	    IF ((lastchar == '/') && (c == '*')) nest++;
	    IF ((lastchar == '*') && (c == '/')) nest--;
	    *cptr++ = c;
	    lastchar = c;
	    c = getchar();
	  ENDLOOP
	*cptr++ = c;
	GOTO lup;
      ENDIF
    IF (c == '"')
      THEN
	lastchar = '\\';
	WHILE (c != '"' || lastchar == '\\')
	  LOOP
	    *cptr++ = c;
	    lastchar = c;
	    c = getchar();
	  ENDLOOP
	*cptr++ = c;
	IF (c == '\\' && lastchar == '\\')
	  THEN
	    *cptr++ = c;
	    lastchar = 0;
	    c = getchar();
	  ENDIF
	GOTO lup;
      ENDIF

    IF (c == '\'')
      THEN
	lastchar = '\\';
	WHILE (c != '\'' || lastchar == '\\')
	  LOOP
	    *cptr++ = c;
	    lastchar = c;
	    c = getchar();
	    IF (c == '\\' && lastchar == '\\')
	      THEN
		*cptr++ = c;
		lastchar = 0;
		c = getchar();
	      ENDIF
	  ENDLOOP
	*cptr++ = c;
	GOTO lup;
      ENDIF

    IF (isalpha(c) || c == '_' || isdigit(c))
      THEN
	*cptr++ = c;
	GOTO lup;
      ENDIF
    *cptr++ = 0;
    *dptr = c;
    lastchar = c;
    RETURN 1;
  END

FUNCTION upper_case(cptr)
CHAR *cptr;
  BEGIN
    WHILE (*cptr != 0)
      LOOP
	*cptr = toupper(*cptr);
	cptr++;
      ENDLOOP
  END

/*****************************************************/
/*	STREQU - STRING EQUAL (IGNORES CASE)         */
/*	RETURNS:         1 IF EQUAL                  */
/*		         0 IF NOT EQUAL              */
/*****************************************************/

strequ(s1,s2)
CHAR *s1,*s2;
BEGIN
    WHILE (toupper(*s1++) == toupper(*s2++)) 
	    IF (!*s1 && !*s2) RETURN (1);
    RETURN (0);
END
