/*
%CC1 $1.C -X -E5000
%CLINK $1 DIO  -S
%DELETE $1.CRL 
*/
/*********************************************************************
*                               MERGE                                *
**********************************************************************
*                  COPYRIGHT 1983 EUGENE H. MALLORY                  *
*********************************************************************/

#INCLUDE "BDSCIO.H"
#INCLUDE "DIO.H"

INT string_compare();
INT i;
INT flag;
CHAR s1[MAXLINE];
CHAR s2[MAXLINE];
INT nocase,reverse,pos,len,file_only,input_only,duplicate;
INT merge;
FILE fcb;

MAIN(argc,argv)
CHAR **argv;
INT argc;

BEGIN
	
    dioinit(&argc,argv);
    
/*********************************************************************
***               ARGUMENT PROCESSING                              ***
*********************************************************************/

merge = 1;
nocase = reverse = pos = len = input_only = file_only = duplicate = 0;

INT ii,jj,optionerr;
CHAR *ss;
	optionerr = 0;
	
	FOR (ii=argc-1;ii>0;ii--)
	    IF (argv[ii][0] == '-')
		BEGIN
		    FOR (ss = &argv[ii][1]; *ss != '\0';)
			BEGIN
			    SWITCH (toupper(*ss++))
				BEGIN
				    CASE 'L':
					len = atoi(ss);
					BREAK;
				    CASE 'U':
					nocase = 1;
					BREAK;
				    CASE 'R':
					reverse = 1;
					BREAK;
				    CASE 'D':
					duplicate = 1;
					BREAK;
				    CASE 'C':
					pos = atoi(ss);
					BREAK;
				    CASE 'I':
					input_only = 1;
					BREAK;;
				    CASE 'F':
					file_only = 1;
					BREAK;
				    CASE 'H':
					optionerr = TRUE;
					BREAK;
				    DEFAULT:
					typef("MERGE: Illegal option %c.\n"
						,*--ss);
					ss++;
					optionerr = TRUE;
					BREAK;
				END
			    WHILE (isdigit(*ss)) ss++;
			END
		    FOR (jj=ii;jj<(argc-1);jj++) argv[jj] = argv[jj+1];
		    argc--;
		END

	IF (optionerr) 
	    BEGIN
		typef("MERGE: Legal options are:\n");
		typef("-U     Upper case compares.\n");
		typef("-R     Reverse sort.\n");
		typef("-Cn    Column Position to begin compare.\n");
		typef("-Ln    Length of string to compare.\n");
		typef("-D     Output duplicate lines.\n");
		typef("-I     Output non-matching input lines.\n");
		typef("-F     Output non-matching lines in named file.\n");
		exit(0);
	    END
	    
    IF (argc < 2) error("MERGE: No file name given.");
    IF (fopen(argv[1],fcb) == -1) 
	error("MERGE: Unable to open file %s.",argv[1]);
    IF (len == 0) len = MAXLINE;
    IF (pos > 0) pos--;
    IF (duplicate || input_only || file_only) 
	merge = 0;

/*********************************************************************
***                  END OF ARGUMENT PROCESSING                    ***
*********************************************************************/
    
    IF (!fgets(s2,fcb)) goto fileeof;
getinput:
    IF (getstring(s1)) goto inputeof;
mainloop:
    flag = string_compare(s1,s2);
    IF (flag == 0)
	BEGIN
	    IF (duplicate ||  merge) puts(s1);
	    IF (input_only) IF (getstring(s1)) goto inputeof;
	    IF (file_only || merge || duplicate)
			IF (!fgets(s2,fcb)) goto fileeof;
	    goto mainloop;
	END
    ELSE IF (flag>0)
	BEGIN
	    IF (merge || file_only) puts(s2);
	    goto getfile;
	END
    ELSE
	BEGIN
	    IF (merge || input_only) puts(s1);
	    goto getinput;
	END
getfile:
    IF (!fgets(s2,fcb)) goto fileeof;
    goto mainloop;
	
inputeof:
    IF (merge || file_only)
	BEGIN
	    DO
		puts(s2);
	    WHILE (fgets(s2,fcb));
	END
    goto done;
    
fileeof:
    fclose(fcb);
    IF (merge || input_only)
	BEGIN
	    DO
		puts(s1);
	    WHILE (!getstring(s1));
	END
done:    
    dioflush();	
END

INT string_compare(s1,t1)
CHAR *s1,*t1;
BEGIN
    INT i;
    IF ((strlen(s1) <= pos) && (strlen(t1) <= pos)) RETURN 0;
    IF (strlen(s1)<=pos) 
	IF (!reverse) RETURN -1;
	ELSE RETURN 1;
    IF (strlen(t1)<=pos) 
	IF (!reverse) RETURN 1;
	ELSE RETURN -1;
    IF (nocase)
    BEGIN
	FOR (i=pos;i<pos+len;i++)
	    BEGIN
		IF (toupper(s1[i]) != toupper(t1[i])) 
		    IF (!reverse) RETURN toupper(s1[i])-toupper(t1[i]);
			ELSE RETURN toupper(t1[i])-toupper(s1[i]);
		IF (s1[i] == '\0')  RETURN 0;
	    END
	RETURN 0;
    END
    ELSE
    BEGIN
	FOR (i=pos;i<pos+len;i++)
	    BEGIN
		IF (s1[i] != t1[i]) 
		    IF (!reverse) RETURN s1[i] - t1[i];
			ELSE RETURN t1[i]-s1[i];
		IF (s1[i] == '\0')  RETURN 0;
	    END
	RETURN 0;
    END
END
