/*
%CC1 $1.C -X 
%l2 $1 DIO WILDEXP -L MYLIB -WA
%COPY $1.COM A: -ov
%DELETE $1.CRL $1.COM
*/
/*********************************************************************
*                                PRINT                               *
**********************************************************************
*                  COPYRIGHT 1983 EUGENE H. MALLORY                  *
*********************************************************************/
#INCLUDE "BDSCIO.H"
#INCLUDE "DIO.H"

INT wait, help, quality, raw, numbering, lines;
INT margin, length, printer, vertical, char_pitch;
INT oldiobyte;
CHAR time[20],date[20];

MAIN(argc,argv)
INT argc;
CHAR **argv;
  BEGIN
    dioinit(&argc,argv);  	/* INITIALIZE DIO BUFFERS AND FLAGS */
    IF (!DIOOUT) _outptr = STDLST;  	/* DEFAULT OUTPUT TO PRINTER */

    do_options(&argc,argv);  	/* PERFORM OPTION PROCESSING */

    wildexp(&argc,&argv);  	/* EXPAND FILE NAMES */

    set_printer();

    time_string(time);
    date_string(date);

    IF (!raw) lines -= 6;
    IF (lines < 1) error("PRINT: Page size too small.");
    
    WHILE (--argc)
      LOOP
        filecopy(*++argv);
      ENDLOOP
    IF (DIOIN) 
      THEN
        dicopy();
      ENDIF
    unset_printer();
    dioflush();
  END

filecopy(fname)
CHAR *fname;
  BEGIN
    FILE fcb;
    CHAR string[MAXLINE],c;
    INT lineno,ln,pgn,i;
    IF (fopen(fname,fcb) == ERROR)
      THEN
        typef("PRINT: Unable to open file \'%s\'.\N",fname);
        RETURN;
      ENDIF
    lineno = ln  = 0;
    pgn = 1;
    WHILE (fgets(string,fcb))
      LOOP
        IF (string[0] == '\014')
          THEN
               ln = 0;
               for (i=1;string[i] != 0; i++) string[i-1] = string[i];
               string[i-1] = string[i];
               puts("\014");
          ENDIF
        IF (ln%lines == 0)
          THEN
            IF (wait)
              THEN
                typef("PRINT: File %s. Hit return to continue.\n",fname);
                WHILE (!(c = BDOS(6,0xff)));
                IF (c == '\033') BREAK;
              ENDIF
            IF (printer == 0) printf("\014");
            IF (!raw)
              THEN
                printf("\n");
                marg(margin);
                printf("Pg. %d   %s  %s   FILE: %s\n\n",pgn++,date,time,fname);
              ENDIF
          ENDIF
        marg(margin);
        IF (numbering)
          THEN
            printf("%7d ",++lineno);
          ENDIF
        puts(string);
        ln++;
        IF (ln%lines==0 && !raw)
          THEN
            printf("\014");
          ENDIF
        IF (bdos(6,0xff) == '\033') BREAK;
      ENDLOOP
    IF (ln%lines !=0) 
      THEN
        IF (!raw) printf("\014");
      ENDIF
    fclose(fcb);
  END

dicopy()
  BEGIN
    INT lineno,ln,pgn,i;
    CHAR string[MAXLINE],c;
    lineno = ln = 0;
    pgn = 1;
    WHILE (!getstring(string))
      LOOP
        IF (string[0] == '\014')
          THEN
               ln = 0;
               for (i=1;string[i] != 0; i++) string[i-1] = string[i];
               string[i-1] = string[i];
               puts("\014");
          ENDIF
        IF (ln%lines == 0)
          THEN
            IF (wait)
              THEN
                typef("PRINT: Hit return to continue.\n");
                WHILE (!(c = BDOS(6,0xff)));
                IF (c == '\033') BREAK;
              ENDIF
            IF (printer == 0) printf("\014");
            IF (!raw)
              THEN
                printf("\n");
                marg(margin);
                printf("Pg. %d    %s %s \n\n",pgn++,date,time);
              ENDIF
          ENDIF
        marg(margin);
        IF (numbering)
          THEN
            printf("%7d ",++lineno);
          ENDIF
        puts(string);
        ln++;
        IF (ln%lines==0 && !raw)
          THEN
            printf("\014");
          ENDIF
        IF (bdos(6,0xff) == '\033') BREAK;
      ENDLOOP
    IF (ln%lines !=0) 
      THEN
        IF (!raw) printf("\014");
      ENDIF
  END

/****************************************************************
                     OUTPUT MARGIN STRING
****************************************************************/
marg(n)
INT n;
  BEGIN
    INT i;
    FOR(i=1;i<=n;i++) putchar(' ');
  END

/*********************************************************************
***               OPTION PROCESSING                                ***
*********************************************************************/
do_options(argcptr,argv)
INT *argcptr;
CHAR **argv;
  BEGIN
    INT ii,jj;
    CHAR *ss;
    wait = help = quality = raw = numbering = FALSE;
    margin = 0;
    length = 22;
    printer = 1;
    vertical = 6;
    char_pitch = 10;

    FOR (ii=*argcptr-1;ii>0;ii--)
    IF (argv[ii][0] == '-')
      THEN
        FOR (ss = &argv[ii][1]; *ss != '\0';)
          LOOP
            SWITCH (toupper(*ss++))
              BEGIN
              CASE 'W':
                wait = TRUE;
                BREAK;
              CASE 'R':
                raw = TRUE;
                BREAK;
              CASE 'M':
                margin = atoi(ss);
                BREAK;
              CASE 'L':
                length = atoi(ss);
                BREAK;
              CASE 'H':
                help = TRUE;
                BREAK;
              CASE 'N':
                numbering = TRUE;
                BREAK;
              CASE 'P':
                printer = atoi(ss);
                BREAK;
              CASE 'Q':
                quality = TRUE;
                BREAK;
              CASE 'V':
                vertical = atoi(ss);
                BREAK;
              CASE 'C':
                char_pitch = atoi(ss);
                BREAK;
              DEFAULT:
                typef("PRINT: Illegal option %c.\n",*--ss);
                ss++;
                help = TRUE;
                BREAK;
              END
            WHILE (isdigit(*ss)) ss++;
          ENDLOOP
        FOR (jj=ii;jj<(*argcptr-1);jj++) argv[jj] = argv[jj+1];
        *argcptr = *argcptr - 1;
      ENDIF

    IF (*argcptr < 2 && !DIOIN) help = TRUE;

    IF (help) 
      THEN
        typef("PRINT: Legal options are:\n");
        typef("-Ln    Length in half inches (default 22).\n");
        typef("-N     Number lines.\n");
        typef("-H     Help.\n");
        typef("-W     Wait for keyin before each page.\n");
        typef("-Mn    Set left margin n (default 0).\n");
        typef("-R     Raw, no formatting at all.\n");
        typef("-Pn    Printer number (default 1).\n");
        typef("-Q     Quality printing.\n");
        typef("-Vn    Vertical spacing (lines/inch) (default 6).\n");
        typef("-Cn    Character spacing (char/inch) (default 10).\n");
        exit(0);
      ENDIF

    IF (printer > 2 || printer < 0) 
    error("PRINT: Printer must be 0, 1 or 2");
    IF (vertical >= 10 || vertical < 1) 
    error("PRINT: Vertical must be from 1 to 10");
    IF (char_pitch > 20 || char_pitch < 1) 
    error("PRINT: Character spacing must be from 1 to 20");
  END

/****************************************************************
                        PRINTER SETUP
****************************************************************/
set_printer()
  BEGIN
    INT i;
    oldiobyte = bdos(7);
    SWITCH(printer)
      BEGIN
      CASE 1:
        bdos(8,0x80|(oldiobyte&0x3f));
        IF (quality) printf("\0331");
        printf("\033%%9%c",144/vertical);
        lines = length*vertical/2;
        printf("\033G%02d",length);
        IF (char_pitch <= 5) printf("\036\037");
        IF (char_pitch <= 8  && char_pitch >5) printf("\035\037");
        IF (char_pitch <= 9  && char_pitch >8) printf("\034\037");
        IF (char_pitch <= 11 && char_pitch >9) printf("\036");
        IF (char_pitch <= 14 && char_pitch >11) printf("\035");
        IF (char_pitch >14) printf("\034");
        printf("\033\t");
        FOR (i=0;i<15;i++)
          LOOP
            printf("%03d",(i*8 + 9 + margin));
            IF (i < 14) printf(",");
          ENDLOOP
        printf("\r");
        printf("\0335");
        BREAK;
      CASE 2:
        bdos(8,0xc0|(oldiobyte&0x3f));
        printf("\033L%02d",48/vertical);
        lines = length*vertical/2;
        printf("\033E%02d",120/char_pitch);
        printf("\0332\033(");
        FOR (i=0;i<15;i++)
          LOOP
            printf("%1x%1d",(i*8 + 8 + margin)/10,(i*8 + 8 + margin)%10);
            IF (i < 14) 
              THEN
                printf(",");
              ENDIF
          ENDLOOP
        printf(".");
        marg(margin);
        printf("\0339");
        margin = 0;
        wait = TRUE;
        BREAK;
      DEFAULT:
        bdos(8,(oldiobyte&0x3f));
        margin = 0;
        wait = raw = TRUE;
        IF (char_pitch > 10) printf("\033[?3h");
        lines = 22;
        BREAK;
      END
  END

/****************************************************************
                      UNSET PRINTER
****************************************************************/
unset_printer()
  BEGIN
    INT i;
    SWITCH(printer)
      BEGIN
      CASE 1:
        printf("\033\t");
        FOR (i=0;i<15;i++)
          LOOP
            printf("%03d",(i*8 + 9));
            IF (i < 14) printf(",");
          ENDLOOP
        printf("\r");
        printf("\014");
        printf("\0330");
        printf("\0336");
        printf("\033G22");
        printf("\0335");
        BREAK;
      CASE 2:
        printf("\033\032I");
        BREAK;
      DEFAULT:
        typef("PRINT: Printing Complete. Hit return to exit.\n");
        WHILE (!BDOS(6,0xff));
        printf("\033[?3l");
        BREAK;
      END
    bdos(8,oldiobyte);
  END
