/*
%CC1 $1.C -X -E6000
%CLINK $1 DIO WILDEXP -S
%DELETE $1.CRL 
*/
/*********************************************************************
*                             SEARCH                                 *
**********************************************************************
*                  COPYRIGHT 1983 EUGENE H. MALLORY                  *
*********************************************************************/
#INCLUDE "BDSCIO.H"
#INCLUDE "DIO.H"

#DEFINE AND &&
#DEFINE OR ||
#DEFINE EQUAL ==
#DEFINE NOTEQUAL !=
#DEFINE NOT !
#DEFINE found 0x80
#DEFINE notfound 0x81
#DEFINE match 0x82
#DEFINE notmatch 0x83
#DEFINE notbegin 0xFF
#DEFINE notend 0x8A
#DEFINE skipany 0x86
#DEFINE skipone 0x87
#DEFINE lineend 0x0A
#DEFINE linestart 0x7F
#DEFINE anyalpha 0x12
#DEFINE anynumber 0x14
CHAR string[MAXLINE+1];
CHAR pattern[MAXLINE+1];
INT i,j,exclude,listline,firstpat,nextpat,lino;
MAIN(argc,argv)
CHAR **argv;
INT argc;

  BEGIN
    CHAR c,fname[MAXLINE];
    INT argi;
    INT string_compare();
    dioinit(&argc,argv);


/*********************************************************************
***               ARGUMENT PROCESSING                              ***
*********************************************************************/
    firstpat = nextpat = lino = 0;
    exclude = listline = FALSE;
    INT ii,jj,optionerr;
    CHAR *ss;
    optionerr = FALSE;
    FOR (ii=argc-1;ii>0;ii--)
    IF (argv[ii][0] == '-')
      THEN
	FOR (ss = &argv[ii][1]; *ss != '\0';)
	  LOOP
	    SWITCH (toupper(*ss++))
	      BEGIN
	      CASE 'L':
		listline = 1;
		BREAK;
	      CASE 'X':
		exclude = 1;
		BREAK;
	      CASE 'N':
		lino = 1;
		BREAK;
	      CASE 'H':
		optionerr = TRUE;
		BREAK;
	      DEFAULT:
		typef("Sv]: Illegal option %c.\n"
		,*--ss);
		ss++;
		optionerr = TRUE;
		BREAK;
	      END
	    WHILE (isdigit(*ss)) ss++;
	  ENDLOOP
	FOR (jj=ii;jj<(argc-1);jj++) argv[jj] = argv[jj+1];
	argc--;
      ENDIF

    IF (optionerr) 
      THEN
	typef("SEARCH: Legal options are:\n");
	typef("-X     Don't list file name.\n");
	typef("-N     Number selected lines.\n");
	typef("-L     List lines where pattern is found.\n");
	typef("Meta characters are:.\n");
	typef("* - Any character string.\n");
	typef("? - Any single character.\n");
	typef("_ - A space.\n");
	typef("\\ - A literal character follows.\n");
	typef("{ - Beginning of line.\n");
	typef("} - End of line.\n");
	typef("@ - Any alphabetic character.\n");
	typef("# - Any numeric character.\n");
	typef("! - NOT the character that follows.\n");
	exit(0);
      ENDIF
    IF (argc < 2) error("SEARCH: One pattern argument required.");
/*********************************************************************
***                  END OF ARGUMENT PROCESSING                    ***
*********************************************************************/
    /* Now that optons are gone, get pattern */
    setuppat(argv[1],pattern);
    argv = &argv[1];
    argc -= 1;
    /* Now wildcard and sort what is left */
    wildexp(&argc,&argv);
    qsort(&argv[1],argc-1,2,&string_compare);  
    FOR ( argi=1;argi<argc;argi++)
      LOOP
	searchfile(argv[argi]);
      ENDLOOP
    IF (DIOIN)
      THEN
	WHILE (!getstring(fname)) searchfile(fname);
      ENDIF
    dioflush();
  END


searchfile(fname)
CHAR *fname;
  BEGIN
    INT linum,onceflag;
    FILE fcb;
    linum = 1;
    onceflag = TRUE;
    IF (ERROR == fopen(fname,fcb)) return;
    WHILE (fgets(&string[1],fcb))
      LOOP
	string[0] = linestart;
	IF (find(0) EQUAL found)
	  THEN
	    IF (!exclude && onceflag)
	    printf("%s\n",fname);
	    IF (listline)
	      THEN
		IF (lino) printf("%7d ",linum);
		puts(&string[1]);
	      ENDIF
	    ELSE 
		THEN
		    fclose(fcb);
		    RETURN;
		ENDIF
	    onceflag = FALSE;
	  ENDIF
	linum++;
      ENDLOOP
    fclose(fcb);
  END

find(first)
INT first;
  BEGIN
    i=0;
    j=first;
    firstpat = first;
    loop:
    SWITCH(search())
      BEGIN
      CASE match:
	IF (i  EQUAL 0) firstpat = j;
	i++;
	j++;
	IF (pattern[i]  EQUAL 0)
	  THEN
	    nextpat = j;
	    IF (pattern[0] EQUAL notbegin)
	    firstpat++;
	    IF (pattern[strlen(pattern)-1] EQUAL notend)
	    nextpat--;
	    RETURN found;
	  ENDIF
	IF (string[j] EQUAL 0) RETURN notfound;
	goto loop;
      CASE notmatch:
	firstpat++;
	j = firstpat;
	IF (string[j] EQUAL 0) RETURN notfound;
	i = 0;
	GOTO loop;
      CASE found:
	nextpat = j;
	IF (pattern[0] EQUAL notbegin)
	firstpat++;
	IF (pattern[strlen(pattern)-1] EQUAL notend)
	nextpat--;
	RETURN found;
      CASE notfound:
	RETURN notfound;
      END
  END

search()
  BEGIN
    INT c,isave;
    SWITCH (pattern[i])
      BEGIN
      CASE 0:
	RETURN found;
      CASE anyalpha:
	IF (isalpha(string[j]))
	RETURN match;
	ELSE RETURN notmatch;
      CASE anynumber:
	IF (isdigit(string[j]))
	RETURN match;
	ELSE RETURN notmatch;
      CASE anyalpha|0x80:
	IF (!isalpha(string[j])
	AND j NOTEQUAL 0AND string[j] NOTEQUAL lineend)RETURN match;
	ELSE RETURN notmatch;
      CASE anynumber|0x80:
	IF (!isdigit(string[j])
	AND j NOTEQUAL 0AND string[j] NOTEQUAL lineend)RETURN match;
	ELSE RETURN notmatch;
      CASE skipany:
	i++;
	IF (pattern[i] EQUAL 0)
	  THEN
	    j = strlen(string);
	    RETURN found;
	  ENDIF
	isave = i;
	loop: i = isave;
	loop2: SWITCH(search())
	  BEGIN
	  CASE match:
	    i++;
	    IF (pattern[i] EQUAL 0)
	      THEN
		i--;
		RETURN match;
	      ENDIF
	    j++;
	    IF (string[j] EQUAL 0)
	      THEN
		i--;
		j--;
		RETURN notfound;
	      ENDIF
	    GOTO loop2;
	  CASE notmatch:
	    j++;
	    IF (string[j] EQUAL 0)
	      THEN
		j--;
		RETURN notmatch;
	      ENDIF
	    GOTO loop;
	  CASE found:
	    RETURN found;
	  CASE notfound:
	    RETURN notfound;
	  END
      CASE skipone:
	IF (string[j] EQUAL '\n') RETURN notfound;
	IF (j EQUAL 0) RETURN notmatch;
	i++;
	j++;
	IF (string[j] EQUAL 0) return notfound;
	SWITCH(search())
	  BEGIN
	  CASE match:
	    RETURN match;
	  CASE notmatch:
	    j--;
	    RETURN notmatch;
	  CASE found:
	    RETURN found;
	  CASE notfound:
	    RETURN notfound;
	  END
      DEFAULT:
	c = pattern[i];
	IF (c & 0x80)
	  THEN
	    IF ((c&0x7f) NOTEQUAL toupper(string[j])
	    AND j NOTEQUAL 0AND string[j] NOTEQUAL lineend)RETURN match;
	    ELSE RETURN notmatch;
	  ENDIF
	ELSE
	  THEN
	    IF (c EQUAL toupper(string[j]))
	    RETURN match;
	    ELSE RETURN notmatch;
	  ENDIF
      END
  END

setuppat(pat,str)
CHAR *pat;
CHAR *str;
  BEGIN
    INT pi,c;
    pi = 0;
    WHILE (c = pat[pi++])
      LOOP
	SWITCH (c)
	  BEGIN
	  CASE '*':
	    *str++ = skipany;
	    IF (pat[pi] EQUAL '!'
	    &&pat[pi+1] EQUAL '}')
	    error("SEARCH: *!} not allowed.");
	    BREAK;
	  CASE '?':
	    *str++ = skipone;
	    BREAK;
	  CASE '}':
	    *str++ = lineend;
	    IF (pat[pi] NOTEQUAL 0)
	    error("SEARCH: } must be last.");
	    BREAK;
	  CASE '{':
	    *str++ = linestart;
	    IF (pi NOTEQUAL 1)
	    error("SEARCH: { must be first.");
	    BREAK;
	  CASE '@':
	    *str++ = anyalpha;
	    BREAK;
	  CASE '#':
	    *str++ = anynumber;
	    BREAK;
	  CASE '_':
	    *str++ = ' ';
	    BREAK;
	  CASE '\\':
	    c = pat[pi++];
	    IF (c EQUAL 0 OR c EQUAL '\n')
	    error("SEARCH: Bad pattern, \\ requires character following.");
	    *str++ = c;
	    BREAK;
	  CASE '!':
	    c = pat[pi++];
	    IF (c < 0x20)
	    error("SEARCH: Bad pattern after !.");
	    SWITCH(c)
	      BEGIN
	      CASE '*':
	      CASE '?':
	      CASE '!':
	      CASE 0:
		error ("SEARCH: Bad pattern after !.");
	      CASE '}':
		*str++ = notend;
		IF (pat[pi] NOTEQUAL 0)
		error("SEARCH: !} must be last.");
		IF (pi EQUAL 2)
		error("SEARCH: No pattern before !}.");
		BREAK;
	      CASE '{':
		*str++ = notbegin;
		IF (pi NOTEQUAL 2)
		error("SEARCH: !{ must be first.");
		IF (pat[pi] EQUAL 0)
		error("SEARCH: No pattern after !{.");
		IF (pat[pi] EQUAL '*')
		error("SEARCH: !{* not allowed.");
		IF (pat[pi] EQUAL '!'
		&&pat[pi+1] EQUAL '}')
		error("SEARCH: !{!} not allowed.");
		BREAK;
	      CASE '@':
		*str++ = anyalpha|0x80;
		BREAK;
	      CASE '#':
		*str++ = anynumber|0x80;
		BREAK;
	      CASE '_':
		*str++ = ' '|0x80;
		BREAK;
	      CASE '\\':
		c = pat[pi++];
		IF (c EQUAL 0 OR c EQUAL '\n' OR c < 0x20)
		error("SEARCH: Bad pattern after !\\.");
		*str++ = c|0x80;
		BREAK;
	      DEFAULT:
		*str++ = c|0x80;
	      END
	    BREAK;
	  DEFAULT:
	    *str++ = c;
	  END
      ENDLOOP
    *str = 0;
  END

INT string_compare(s,t)
CHAR **s, **t;
  BEGIN
    CHAR *s1, *t1;
    INT i;
    s1 = *s;
    t1 = *t;
    FOR (i=0;i<MAXLINE;i++)
      LOOP
	IF (t1[i] != s1[i]) 
	RETURN s1[i] - t1[i];
	IF (s1[i] == '\0') RETURN 0;
      ENDLOOP
    RETURN 0;
  END
