/*
%CC1 $1.C -X -E3E00
%l2 $1 DIO  -WA
%COPY $1.COM A: -O
%DELETE $1.CRL $1.COM
*/
/*********************************************************************
*                               SORT                                 *
**********************************************************************
*                  COPYRIGHT 1983 EUGENE H. MALLORY                  *
*********************************************************************/

#INCLUDE "bdscio.h"
#INCLUDE "DIO.H"


STRUCT tnode
    BEGIN
	STRUCT tnode *left;
	STRUCT tnode *right;
	CHAR text[MAXLINE];
    END;
	    
INT nocase,reverse,pos,len;
INT bot,top,dif,try,next;
INT rctr,lctr,maxr,maxl;

MAIN(argc,argv)
CHAR **argv;
INT argc;

BEGIN
	
INT i,j,linectr;
STRUCT tnode *root,*space;
CHAR line_buf[MAXLINE];

    dioinit(&argc,argv);
    
/*********************************************************************
***               ARGUMENT PROCESSING                              ***
*********************************************************************/

nocase = reverse = pos = len = 0;

INT ii,jj,optionerr;
CHAR *ss;
	optionerr = 0;
	
	FOR (ii=argc-1;ii>0;ii--)
	    IF (argv[ii][0] == '-')
		BEGIN
		    FOR (ss = &argv[ii][1]; *ss != '\0';)
			BEGIN
			    SWITCH (toupper(*ss++))
				BEGIN
				    CASE 'L':
					len = atoi(ss);
					BREAK;
				    CASE 'U':
					nocase = 1;
					BREAK;
				    CASE 'R':
					reverse = 1;
					BREAK;
				    CASE 'C':
					pos = atoi(ss);
					BREAK;
				    CASE 'H':
					optionerr = TRUE;
					BREAK;
				    DEFAULT:
					typef("SORT: Illegal option %c.\n"
						,*--ss);
					ss++;
					optionerr = TRUE;
					BREAK;
				END
			    WHILE (isdigit(*ss)) ss++;
			END
		    FOR (jj=ii;jj<(argc-1);jj++) argv[jj] = argv[jj+1];
		    argc--;
		END
	
	    
	IF (optionerr) 
	    BEGIN
		typef("SORT:  Legal options are:\n");
		typef("-R     Reverse order sort.\n");
		typef("-U     Upper case compare.\n");
		typef("-Cn    Column to begin compare.\n");
		typef("-Ln    Length of string to compare.\n");
		exit(0);
	    END
	    
    IF (len == 0) len = MAXLINE;
    IF (pos > 0) pos--;
    
/*********************************************************************
***                  END OF ARGUMENT PROCESSING                    ***
*********************************************************************/

    root = NULL;
    maxl = maxr = linectr = 0;
    rsvstk(2000);
    
    WHILE (TRUE)
	BEGIN
	    IF (getstring(line_buf)) BREAK;
	    linectr++;
	    space = sbrk(strlen(line_buf) + 1+2+2);
	    IF (space == -1)
		error("SORT: Out of space at line %d.",linectr);
	    strcpy(space->text,line_buf);
	    space->left = NULL;
	    space->right = NULL;
	    rctr = lctr = 0;
	    install(&root,&space,&root);
	END
    
    rctr = lctr = 0;
    IF (root != NULL)
	treeprint(root);
    dioflush();	
END
	    
install(nodeptr,spaceptr,rootptr)
STRUCT tnode **nodeptr,**spaceptr,**rootptr;
BEGIN
INT state;
    IF (*nodeptr == NULL)
	BEGIN
	    IF (rctr == 0 && lctr > 30)
		BEGIN
		    (*spaceptr)->right = (*rootptr);
		    *rootptr = *spaceptr;
		END
	    ELSE IF (lctr == 0 && rctr > 30)
		BEGIN
		    (*spaceptr)->left = (*rootptr);
		    *rootptr = *spaceptr;
		END
	    ELSE
		BEGIN
		    *nodeptr = *spaceptr;
		END
	    return;
	END
    ELSE
	BEGIN
	    state = string_compare((*nodeptr)->text,(*spaceptr)->text);
	    IF (state > 0)
		BEGIN
left:		    
		    lctr++;
		    install(&((*nodeptr)->left),spaceptr,rootptr);
		    return;
		END
	    ELSE
		BEGIN
right:		    
		    rctr++;
		    install(&((*nodeptr)->right),spaceptr,rootptr);
		    return;
		END
	END
END
		    
treeprint(nodeptr)
STRUCT tnode *nodeptr;
BEGIN
    IF (lctr>maxl) maxl=lctr;
    IF (rctr>maxr) maxr=rctr;

    IF (nodeptr->left != NULL)
	BEGIN
	    lctr++;
	    treeprint(nodeptr->left);
	    lctr--;
	END

    puts(nodeptr->text);

    IF (nodeptr->right != NULL)
	BEGIN
	    rctr++;
	    treeprint(nodeptr->right);
	    rctr--;
	END
END


INT string_compare(s1,t1)
CHAR *s1,*t1;
BEGIN
INT i,j;

    IF ((strlen(s1) <= pos) && (strlen(t1) <= pos)) RETURN 0;
    IF (strlen(s1)<=pos) 
	IF (!reverse) RETURN -1;
	ELSE RETURN 1;
    IF (strlen(t1)<=pos) 
	IF (!reverse) RETURN 1;
	ELSE RETURN -1;
    IF (nocase)
    BEGIN
	FOR (i=pos;i<pos+len;i++)
	    BEGIN
		IF (toupper(s1[i]) != toupper(t1[i])) 
		    IF (!reverse) RETURN toupper(s1[i])-toupper(t1[i]);
			ELSE RETURN toupper(t1[i])-toupper(s1[i]);
		IF (s1[i] == '\0')  RETURN 0;
	    END
	RETURN 0;
    END
    ELSE
    BEGIN
	FOR (i=pos;i<pos+len;i++)
	    BEGIN
		IF (s1[i] != t1[i]) 
		    IF (!reverse) RETURN s1[i] - t1[i];
			ELSE RETURN t1[i]-s1[i];
		IF (s1[i] == '\0')  RETURN 0;
	    END
	RETURN 0;
    END
END
